/*! scrawl-canvas 2015-12-02 */
window.requestAnimFrame = function () {
    return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function (a) {
        window.setTimeout(a, 1e3 / 60)
    }
}();
var scrawl = window.scrawl || function () {
    "use strict";
    var a = {};
    a.version = "5.0.3", a.work = {}, a.work.nameslist = ["padnames", "cellnames", "ctxnames", "groupnames", "designnames", "entitynames", "animationnames"], a.work.sectionlist = ["pad", "cell", "canvas", "context", "ctx", "imageData", "group", "design", "dsn", "entity", "animation"], a.work.radian = Math.PI / 180, a.work.d = {}, a.work.v = null, a.work.colv1 = null, a.work.colv2 = null, a.work.o = {}, a.work.workquat = null, a.work.f = document.createDocumentFragment(), a.work.loadAlias = {
        block: "scrawlBlock",
        wheel: "scrawlWheel",
        phrase: "scrawlPhrase",
        path: "scrawlPath",
        shape: "scrawlShape",
        images: "scrawlImages",
        animation: "scrawlAnimation",
        collisions: "scrawlCollisions",
        factories: "scrawlPathFactories",
        color: "scrawlColor",
        filters: "scrawlFilters",
        physics: "scrawlPhysics",
        saveload: "scrawlSaveLoad",
        stacks: "scrawlStacks",
        frame: "scrawlFrame",
        quaternion: "scrawlQuaternion",
        imageload: "scrawlImageLoad"
    }, a.work.extensions = [], a.work.modules = a.work.extensions, a.device = {}, a.work.loadDependencies = {
        block: [],
        wheel: [],
        phrase: [],
        path: [],
        shape: [],
        images: ["imageload"],
        imageload: [],
        animation: [],
        collisions: [],
        factories: [],
        color: [],
        filters: [],
        physics: ["quaternion"],
        saveload: [],
        stacks: ["quaternion"],
        frame: [],
        quaternion: []
    }, a.init = function () {
        return a.entity || (a.reset(), a.device = new a.Device, a.pageInit(), a.createDefaultPad(), a.setDisplayOffsets("all"), a.physicsInit(), a.filtersInit(), a.animationInit()), a
    }, a.pageInit = function () {
        a.device.canvas && a.getCanvases()
    }, a.physicsInit = function () {}, a.filtersInit = function () {}, a.createDefaultPad = function () {
        var b, c, d;
        a.device.canvas && (d = "defaultHiddenCanvasElement", b = a.addCanvasToPage({
            name: d
        }), d = b.name, c = d + "_base", a.removeItem(a.padnames, d), a.removeItem(a.work.activeListeners, d), a.work.f.appendChild(a.canvas[d]), a.work.cv = a.canvas[c], a.work.cvx = a.context[c], a.work.cvmodel = a.ctx[c], a.work.cvwrapper = a.cell[c], a.work.cvcontroller = a.pad[d])
    }, a.reset = function () {
        for (var b = 0, c = a.work.nameslist.length; c > b; b++) a[a.work.nameslist[b]] = [];
        for (var d = 0, e = a.work.sectionlist.length; e > d; d++) a[a.work.sectionlist[d]] = {};
        return a
    }, a.loadExtensions = function (b) {
        b = a.safeObject(b);
        var c, d, e, f, g = b.path || "",
            h = [],
            i = a.isa_fn(b.callback) ? b.callback : function () {},
            j = a.isa_fn(b.error) ? b.error : function () {},
            k = a.xtGet(b.minified, !0),
            l = k ? "-min.js" : ".js",
            m = [],
            n = [],
            o = Date.now(),
            p = 3e4,
            q = function (b) {
                var c, d = a.work.loadAlias[b] || b;
                a.contains(a.work.extensions, d) || (c = document.createElement("script"), c.type = "text/javascript", c.async = "true", c.onload = function () {
                    r(b)
                }, c.onerror = function () {
                    r(b, !0)
                }, c.src = /\.js$/.test(d) ? g + d : g + d + l, document.body.appendChild(c))
            },
            r = function (b, c) {
                a.removeItem(m, b), c || Date.now() > o + p ? j() : a.pushUnique(a.work.extensions, b), 0 === m.length && i()
            };
        for (a.xt(b.extensions) && (h = h.concat([].concat(b.extensions))), a.xt(b.modules) && (h = h.concat([].concat(b.modules))), c = 0, d = h.length; d > c; c++) {
            for (e = 0, f = a.work.loadDependencies[h[c]].length; f > e; e++) a.pushUnique(n, a.work.loadDependencies[h[c]][e]);
            a.pushUnique(n, h[c])
        }
        for (m = [].concat(n), c = 0, d = n.length; d > c; c++) q(n[c]);
        return a
    }, a.loadModules = a.loadExtensions, a.mergeInto = function (b, c) {
        for (var d in c) c.hasOwnProperty(d) && !a.xt(b[d]) && (b[d] = c[d]);
        return b
    }, a.mergeOver = function (a, b) {
        for (var c in b) b.hasOwnProperty(c) && (a[c] = b[c]);
        return a
    }, a.contains = function (a, b) {
        return Array.isArray(a) && a.indexOf(b) >= 0 ? !0 : !1
    }, a.toInt = function (a) {
        return a.substring && (a = parseFloat(a)), a.toFixed ? 0 | a : 0
    }, a.pushUnique = function (a, b) {
        return a.indexOf(b) < 0 && a.push(b), a
    }, a.removeItem = function (a, b) {
        var c = a.indexOf(b);
        return c >= 0 && a.splice(c, 1), a
    }, a.isBetween = function (a, b, c, d) {
        var e;
        return b > c && (e = b, b = c, c = e), d ? a >= b && c >= a ? !0 : !1 : a > b && c > a ? !0 : !1
    }, a.isa = function () {
        return 2 == arguments.length && "undefined" != typeof arguments[0] ? a["isa_" + arguments[1]](arguments[0]) : !1
    }, a.isa_str = function (a) {
        return a && a.substring ? !0 : !1
    }, a.isa_fn = function (a) {
        return "function" == typeof a ? !0 : !1
    }, a.isa_arr = function (a) {
        return Array.isArray(a) ? !0 : !1
    }, a.isa_bool = function (a) {
        return "boolean" == typeof a ? !0 : !1
    }, a.isa_canvas = function (a) {
        return "[object HTMLCanvasElement]" === Object.prototype.toString.call(a) ? !0 : !1
    }, a.isa_date = function (a) {
        return "[object Date]" === Object.prototype.toString.call(a) ? !0 : !1
    }, a.isa_dom = function (a) {
        return a && a.querySelector && a.dispatchEvent ? !0 : !1
    }, a.isa_event = function (a) {
        return a && a.preventDefault && a.initEvent ? !0 : !1
    }, a.isa_img = function (a) {
        return "[object HTMLImageElement]" === Object.prototype.toString.call(a) ? !0 : !1
    }, a.isa_num = function (a) {
        return a && a.toFixed ? !0 : !1
    }, a.isa_realnum = function (a) {
        return a && a.toFixed && !isNaN(a) && isFinite(a) ? !0 : !1
    }, a.isa_obj = function (a) {
        return "[object Object]" === Object.prototype.toString.call(a) ? !0 : !1
    }, a.isa_quaternion = function (a) {
        return a && a.type && "Quaternion" === a.type ? !0 : !1
    }, a.isa_vector = function (a) {
        return a && a.type && "Vector" === a.type ? !0 : !1
    }, a.isa_video = function (a) {
        return "[object HTMLVideoElement]" === Object.prototype.toString.call(a) ? !0 : !1
    }, a.safeObject = function (b) {
        return "[object Object]" === Object.prototype.toString.call(b) ? b : a.work.o
    }, a.xt = function (a) {
        return "undefined" == typeof a ? !1 : !0
    }, a.xtGet = function () {
        var a, b;
        if (arguments.length > 0)
            for (a = 0, b = arguments.length; b > a; a++)
                if ("undefined" != typeof arguments[a]) return arguments[a];
        return null
    }, a.xtGetTrue = function () {
        var a, b;
        if (arguments.length > 0)
            for (a = 0, b = arguments.length; b > a; a++)
                if (arguments[a]) return arguments[a];
        return null
    }, a.xta = function () {
        var a, b, c;
        if (a = arguments, Array.isArray(arguments[0]) && (a = arguments[0]), a.length > 0) {
            for (b = 0, c = a.length; c > b; b++)
                if ("undefined" == typeof a[b]) return !1;
            return !0
        }
        return !1
    }, a.xto = function () {
        var a, b, c;
        if (a = arguments, Array.isArray(arguments[0]) && (a = arguments[0]), a.length > 0)
            for (b = 0, c = a.length; c > b; b++)
                if ("undefined" != typeof a[b]) return !0;
        return !1
    }, a.makeName = function (b) {
        var c, d;
        return b = a.safeObject(b), a.contains(a.work.nameslist, b.target) ? (c = a.xtGetTrue(b.name, b.type, "default"), c = c.replace(/[\.\/ \+\*\[\{\(\)~\-#\\\^\$\|\?]/g, "_"), d = c.split("___"), a.contains(a[b.target], d[0]) ? d[0] + "___" + Math.floor(1e8 * Math.random()) : d[0]) : !1
    }, a.setDisplayOffsets = function () {
        var b, c, d = a.padnames,
            e = a.pad;
        for (b = 0, c = d.length; c > b; b++) e[d[b]].setDisplayOffsets();
        return a
    }, a.getCanvases = function () {
        var b, c, d, e;
        if (b = document.getElementsByTagName("canvas"), b.length > 0) {
            for (d = 0, e = b.length; e > d; d++) c = a.makePad({
                canvasElement: b[d]
            }), 0 === d && (a.work.currentPad = c.name);
            return !0
        }
        return !1
    }, a.addCanvasToPage = function (b) {
        var c, d, e, f = a.xtGet;
        return b = a.safeObject(b), c = document.getElementById(b.parentElement) || document.body, d = document.createElement("canvas"), c.appendChild(d), b.width = f(b.width, 300), b.height = f(b.height, 150), b.canvasElement = d, e = new a.Pad(b), a.setDisplayOffsets(), e
    }, a.clear = function (b) {
        var c, d, e, f = a.pad;
        for (c = b ? [].concat(b) : a.padnames, d = 0, e = c.length; e > d; d++) f[c[d]].clear();
        return a
    }, a.compile = function (b, c) {
        var d, e, f, g = a.pad;
        for (d = b ? [].concat(b) : a.padnames, e = 0, f = d.length; f > e; e++) g[d[e]].compile(c);
        return a
    }, a.show = function (b) {
        var c, d, e, f = a.pad;
        for (c = b ? [].concat(b) : a.padnames, d = 0, e = c.length; e > d; d++) f[c[d]].show();
        return a
    }, a.render = function (b, c) {
        var d, e, f, g = a.pad;
        for (d = b ? [].concat(b) : a.padnames, e = 0, f = d.length; f > e; e++) g[d[e]].render(c);
        return a
    }, a.addPercentages = function (a, b) {
        return a = parseFloat(a), b = parseFloat(b), a + b + "%"
    }, a.reversePercentage = function (a) {
        return a = parseFloat(a), a = -a, a + "%"
    }, a.subtractPercentages = function (a, b) {
        return a = parseFloat(a), b = parseFloat(b), a - b + "%"
    }, a.work.activeListeners = [], window.CustomEvent && (a.triggerTouchEnter = function (b, c) {
        a.updateCustomTouch(b, c, "touchenter")
    }, a.triggerTouchLeave = function (b, c) {
        a.updateCustomTouch(b, c, "touchleave")
    }, a.triggerTouchFollow = function (b, c) {
        a.updateCustomTouch(b, c, "touchfollow")
    }, a.cloneTouchEventItem = function (a) {
        var b = {};
        return b.clientX = a.clientX, b.clientY = a.clientY, b.force = a.force, b.identifier = a.identifier, b.pageX = a.pageX, b.pageY = a.pageY, b.radiusX = a.radiusX, b.radiusY = a.radiusY, b.screenX = a.screenX, b.screenY = a.screenY, b.target = a.target, b
    }, a.updateCustomTouch = function (b, c, d) {
        var e, f, g, h = [],
            i = [],
            j = [],
            k = a.xt,
            l = a.cloneTouchEventItem;
        if (k(b.changedTouches))
            for (f = 0, g = b.changedTouches.length; g > f; f++) h.push(l(b.changedTouches[f]));
        if (k(b.targetTouches))
            for (f = 0, g = b.targetTouches.length; g > f; f++) i.push(l(b.targetTouches[f]));
        if (k(b.touches))
            for (f = 0, g = b.touches.length; g > f; f++) j.push(l(b.touches[f]));
        e = new CustomEvent(d, {
            altKey: b.altKey,
            bubbles: b.bubbles,
            cancelBubble: b.cancelBubble,
            cancelable: b.cancelable,
            changedTouches: h,
            charCode: b.charCode,
            clipboardData: b.clipboardData,
            ctrlKey: b.ctrlKey,
            currentTarget: b.currentTarget,
            defaultPrevented: b.defaultPrevented,
            detail: {},
            eventPhase: b.eventPhase,
            keyCode: b.eventPhase,
            layerX: b.layerX,
            layerY: b.layerY,
            metaKey: b.metaKey,
            pageX: b.pageX,
            pageY: b.pageY,
            path: b.path,
            returnValue: b.returnValue,
            shiftKey: b.shiftKey,
            srcElement: b.srcElement,
            target: b.target,
            targetTouches: i,
            timestamp: b.timestamp,
            touches: j,
            view: b.view,
            which: b.which
        }), c.dispatchEvent(e)
    }), a.addNativeListener = function (b, c, d) {
        var e, f, g, h, i;
        if (a.removeNativeListener(b, c, d), b = [].concat(b), e = d.substring ? document.body.querySelectorAll(d) : Array.isArray(d) ? d : [d], a.isa_fn(c))
            for (h = 0, i = b.length; i > h; h++)
                for (f = 0, g = e.length; g > f; f++) e[f].addEventListener(b[h], c, !1)
    }, a.removeNativeListener = function (b, c, d) {
        var e, f, g, h, i;
        if (b = [].concat(b), e = d.substring ? document.body.querySelectorAll(d) : Array.isArray(d) ? d : [d], a.isa_fn(c))
            for (h = 0, i = b.length; i > h; h++)
                for (f = 0, g = e.length; g > f; f++) e[f].removeEventListener(b[h], c, !1)
    }, a.addListener = function (b, c, d) {
        var e, f, g, h, i, j;
        if (a.removeListener(b, c, d), j = navigator.pointerEnabled || navigator.msPointerEnabled ? !0 : !1, b = [].concat(b), e = d.substring ? document.body.querySelectorAll(d) : Array.isArray(d) ? d : [d], a.isa_fn(c))
            for (h = 0, i = b.length; i > h; h++)
                for (f = 0, g = e.length; g > f; f++)
                    if (a.isa_dom(e[f])) switch (b[h]) {
                        case "move":
                            j ? e[f].addEventListener("pointermove", c, !1) : (e[f].addEventListener("mousemove", c, !1), e[f].addEventListener("touchmove", c, !1), e[f].addEventListener("touchfollow", c, !1));
                            break;
                        case "up":
                            j ? e[f].addEventListener("pointerup", c, !1) : (e[f].addEventListener("mouseup", c, !1), e[f].addEventListener("touchend", c, !1));
                            break;
                        case "down":
                            j ? e[f].addEventListener("pointerdown", c, !1) : (e[f].addEventListener("mousedown", c, !1), e[f].addEventListener("touchstart", c, !1));
                            break;
                        case "leave":
                            j ? e[f].addEventListener("pointerleave", c, !1) : (e[f].addEventListener("mouseleave", c, !1), e[f].addEventListener("touchleave", c, !1));
                            break;
                        case "enter":
                            j ? e[f].addEventListener("pointerenter", c, !1) : (e[f].addEventListener("mouseenter", c, !1), e[f].addEventListener("touchenter", c, !1))
                    }
        return !0
    }, a.removeListener = function (b, c, d) {
        var e, f, g, h, i, j;
        if (b = [].concat(b), j = navigator.pointerEnabled || navigator.msPointerEnabled ? !0 : !1, e = d.substring ? document.body.querySelectorAll(d) : Array.isArray(d) ? d : [d], a.isa_fn(c))
            for (h = 0, i = b.length; i > h; h++)
                for (f = 0, g = e.length; g > f; f++)
                    if (a.isa_dom(e[f])) switch (b[h]) {
                        case "move":
                            j ? e[f].removeEventListener("pointermove", c, !1) : (e[f].removeEventListener("mousemove", c, !1), e[f].removeEventListener("touchmove", c, !1), e[f].removeEventListener("touchfollow", c, !1));
                            break;
                        case "up":
                            j ? e[f].removeEventListener("pointerup", c, !1) : (e[f].removeEventListener("mouseup", c, !1), e[f].removeEventListener("touchend", c, !1));
                            break;
                        case "down":
                            j ? e[f].removeEventListener("pointerdown", c, !1) : (e[f].removeEventListener("mousedown", c, !1), e[f].removeEventListener("touchstart", c, !1));
                            break;
                        case "leave":
                            j ? e[f].removeEventListener("pointerleave", c, !1) : (e[f].removeEventListener("mouseleave", c, !1), e[f].removeEventListener("touchleave", c, !1));
                            break;
                        case "enter":
                            j ? e[f].removeEventListener("pointerenter", c, !1) : (e[f].removeEventListener("mouseenter", c, !1), e[f].removeEventListener("touchenter", c, !1))
                    }
        return !0
    }, a.bucketSort = function (b, c, d) {
        var e, f, g, h, i;
        for (e = [[]], f = 0, g = d.length; g > f; f++) h = Math.floor(a[b][d[f]][c]), e[h] || (e[h] = []), e[h].push(d[f]);
        for (i = [], f = 0, g = e.length; g > f; f++) e[f] && i.push(e[f]);
        return [].concat.apply([], i)
    }, a.correctCoordinates = function (b, c) {
        var d, e, f, g, h = a.xtGet;
        return b = a.safeObject(b), d = a.makeVector(b), a.xta(b.x, b.y) ? (c = a.cell[c] ? a.cell[c] : a.cell[a.pad[a.work.currentPad].base], e = a.pad[c.pad], f = h(e.localWidth, e.width, 300), g = h(e.localHeight, e.height, 150), f !== c.actualWidth && (d.x /= f / c.actualWidth), g !== c.actualHeight && (d.y /= g / c.actualHeight), d) : !1
    }, a.addNewCell = function (b, c) {
        return c = c && c.substring ? c : a.work.currentPad, a.pad[c].addNewCell(b)
    }, a.deleteCells = function () {
        var b, d, e, f, g, h = a.group,
            i = a.groupnames,
            j = a.removeItem;
        for (b = Array.prototype.slice.call(arguments), Array.isArray(b[0]) && (b = b[0]), d = 0, e = b.length; e > d; d++) {
            for (f = 0, g = a.padnames.length; g > f; f++) a.pad[a.padnames[f]].deleteCell(c[d]);
            delete h[b[d]], delete h[b[d] + "_field"], delete h[b[d] + "_fence"], j(i, b[d]), j(i, b[d] + "_field"), j(i, b[d] + "_fence"), delete a.context[b[d]], delete a.canvas[b[d]], delete a.ctx[a.cell[b[d]].context], j(a.ctxnames, a.cell[b[d]].context), delete a.cell[b[d]], j(a.cellnames, b[d])
        }
        return a
    }, a.addEntitysToGroups = function (b, c) {
        var d, e, f, g, h;
        if (a.xta(b, c))
            for (d = [].concat(b), e = [].concat(c), g = 0, h = d.length; h > g; g++) f = a.group[d[g]], f && f.addEntitysToGroup(e);
        return a
    }, a.removeEntitysFromGroups = function (b, c) {
        var d, e, f, g, h;
        if (a.xta(b, c))
            for (d = [].concat(b), e = [].concat(c), g = 0, h = d.length; h > g; g++) f = a.group[d[g]], f && f.removeEntitysFromGroup(e);
        return a
    }, a.deleteEntity = function () {
        var b, c, d, e, f, g, h, i = a.removeItem;
        for (b = Array.prototype.slice.call(arguments), Array.isArray(b[0]) && (b = b[0]), c = 0, d = b.length; d > c; c++)
            if (g = a.entity[b[c]])
                for (a.pathDeleteEntity(g), h = g.context, i(a.ctxnames, h), delete a.ctx[h], i(a.entitynames, b[c]), delete a.entity[b[c]], e = 0, f = a.groupnames.length; f > e; e++) i(a.group[a.groupnames[e]].entitys, b[c]);
        return a
    }, a.pathDeleteEntity = function () {}, a.newVector = function (b) {
        return a.makeVector(b)
    }, a.newPad = function (b) {
        return a.makePad(b)
    }, a.newCell = function (b) {
        return a.makeCell(b)
    }, a.newContext = function (b) {
        return a.makeContext(b)
    }, a.newGroup = function (b) {
        return a.makeGroup(b)
    }, a.newGradient = function (b) {
        return a.makeGradient(b)
    }, a.newRadialGradient = function (b) {
        return a.makeRadialGradient(b)
    }, a.makeVector = function (b) {
        return new a.Vector(b)
    }, a.makePad = function (b) {
        return new a.Pad(b)
    }, a.makeCell = function (b) {
        return new a.Cell(b)
    }, a.makeContext = function (b) {
        return new a.Context(b)
    }, a.makeGroup = function (b) {
        return new a.Group(b)
    }, a.makeGradient = function (b) {
        return new a.Gradient(b)
    }, a.makeRadialGradient = function (b) {
        return new a.RadialGradient(b)
    }, a.setPerspectives = function () {}, a.Vector = function (b) {
        return b = a.safeObject(b), this.x = b.x || 0, this.y = b.y || 0, this.z = b.z || 0, this.name = b.name || "generic", this
    }, a.Vector.prototype = Object.create(Object.prototype), a.Vector.prototype.type = "Vector", a.work.d.Vector = {
        x: 0,
        y: 0,
        z: 0,
        name: "generic"
    }, a.Vector.prototype.setMagnitudeTo = function (a) {
        return this.normalize(), this.scalarMultiply(a), this.getMagnitude() !== a && (this.normalize(), this.scalarMultiply(a), this.getMagnitude() !== a && (this.normalize(), this.scalarMultiply(a))), this
    }, a.Vector.prototype.normalize = function () {
        var a = this.getMagnitude();
        return a > 0 && (this.x /= a, this.y /= a, this.z /= a), this
    }, a.Vector.prototype.zero = function () {
        return this.x = 0, this.y = 0, this.z = 0, this
    }, a.Vector.prototype.set = function (b) {
        b = a.safeObject(b);
        var c = a.xtGet;
        return this.x = c(b.x, this.x), this.y = c(b.y, this.y), this.z = c(b.z, this.z), this
    }, a.Vector.prototype.isEqual = function (b) {
        return a.isa_vector(b) && this.x === b.x && this.y === b.y && this.z === b.z ? !0 : !1
    }, a.Vector.prototype.isLike = function (b) {
        return a.isa_obj(b) && this.x === b.x && this.y === b.y && this.z === b.z ? !0 : !1
    }, a.Vector.prototype.getData = function () {
        return {
            x: this.x,
            y: this.y,
            z: this.z
        }
    }, a.Vector.prototype.hasCoordinates = function (b) {
        return a.xta(b, b.x, b.y) ? !0 : !1
    }, a.Vector.prototype.vectorAdd = function (b) {
        return b = a.safeObject(b), this.x += b.x || 0, this.y += b.y || 0, this.z += b.z || 0, this
    }, a.Vector.prototype.vectorSubtract = function (b) {
        return b = a.safeObject(b), this.x -= b.x || 0, this.y -= b.y || 0, this.z -= b.z || 0, this
    }, a.Vector.prototype.vectorMultiply = function (b) {
        return b = a.safeObject(b), this.x *= b.x || 1, this.y *= b.y || 1, this.z *= b.z || 1, this
    }, a.Vector.prototype.vectorDivide = function (b) {
        return b = a.safeObject(b), this.x /= 0 !== (b.x || 0) ? b.x : 1, this.y /= 0 !== (b.y || 0) ? b.y : 1, this.z /= 0 !== (b.z || 0) ? b.z : 1, this
    }, a.Vector.prototype.scalarMultiply = function (a) {
        return a.toFixed ? (this.x *= a, this.y *= a, this.z *= a, this) : this
    }, a.Vector.prototype.scalarDivide = function (a) {
        return a.toFixed && 0 !== a ? (this.x /= a, this.y /= a, this.z /= a, this) : this
    }, a.Vector.prototype.getMagnitude = function () {
        return Math.sqrt(this.x * this.x + this.y * this.y + this.z * this.z)
    }, a.Vector.prototype.checkNotZero = function () {
        return this.x || this.y || this.z ? !0 : !1
    }, a.Vector.prototype.getVector = function () {
        return a.makeVector({
            x: this.x,
            y: this.y,
            z: this.z
        })
    }, a.Vector.prototype.getCrossProduct = function (b, c) {
        var d, e, f, g, h, i;
        return a.isa_obj(b) ? (c = a.isa_obj(c) ? c : this, d = c.x || 0, e = c.y || 0, f = c.z || 0, g = b.x || 0, h = b.y || 0, i = b.z || 0, a.makeVector({
            x: e * i - f * h,
            y: -(d * i) + f * g,
            z: d * h + e * g
        })) : this
    }, a.Vector.prototype.getDotProduct = function (b, c) {
        return a.isa_obj(b) ? (c = a.isa_obj(c) ? c : this, (b.x || 0) * (c.x || 0) + (b.y || 0) * (c.y || 0) + (b.z || 0) * (c.z || 0)) : !1
    }, a.Vector.prototype.getTripleScalarProduct = function (b, c, d) {
        var e, f, g, h, i, j, k, l, m;
        return a.isa_obj(b) && a.isa_obj(c) ? (d = a.isa_obj(d) ? d : this, e = b.x || 0, f = b.y || 0, g = b.z || 0, h = c.x || 0, i = c.y || 0, j = c.z || 0, k = d.x || 0, l = d.y || 0, m = d.z || 0, e * (i * m - j * l) + f * (-(h * m) + j * k) + g * (h * l - i * k)) : !1
    }, a.Vector.prototype.rotate = function (a) {
        var b = [0, 0];
        return a.toFixed ? (b[0] = Math.atan2(this.y, this.x), b[0] += .01745329251 * a, b[1] = this.getMagnitude(), this.x = b[1] * Math.cos(b[0]), this.y = b[1] * Math.sin(b[0]), this) : this
    }, a.Vector.prototype.reverse = function () {
        return this.x = -this.x, this.y = -this.y, this.z = -this.z, this
    }, a.Vector.prototype.rotate3d = function (b, c) {
        var d, e, f, g;
        return a.isa_quaternion(b) ? (g = a.work.workquat, c = c && c.toFixed ? c : this.getMagnitude(), d = g.q1.set(b), e = g.q2.set(this), f = g.q3.set(b).conjugate(), d.quaternionMultiply(e), d.quaternionMultiply(f), this.set(d.v).setMagnitudeTo(c), this) : this
    }, a.Base = function (b) {
        return b = a.safeObject(b), this.name = a.makeName({
            name: b.name,
            type: this.type,
            target: this.classname
        }), this
    }, a.Base.prototype = Object.create(Object.prototype), a.Base.prototype.type = "Base", a.Base.prototype.classname = "objectnames", a.work.d.Base = {
        comment: "",
        title: "",
        timestamp: ""
    }, a.Base.prototype.get = function (b) {
        return a.xtGet(this[b], a.work.d[this.type][b])
    }, a.Base.prototype.set = function (b) {
        var c = a.work.d[this.type],
            d = a.xt;
        for (var e in b) d(c[e]) && (this[e] = b[e]);
        return this
    }, a.Base.prototype.clone = function (b) {
        var c, d, e, f, g;
        for (c = a.mergeOver(this.parse(), a.safeObject(b)), delete c.context, d = Object.keys(this), e = this, f = 0, g = d.length; g > f; f++) a.isa_fn(this[d[f]]) && (c[d[f]] = e[d[f]]);
        return new a[this.type](c)
    }, a.Base.prototype.parse = function () {
        return JSON.parse(JSON.stringify(this))
    }, a.Base.prototype.numberConvert = function (a, b) {
        var c = parseFloat(a) / 100;
        if (isNaN(c)) switch (a) {
            case "right":
            case "bottom":
                return b;
            case "center":
                return b / 2;
            default:
                return 0
        }
        return c * b
    }, a.Device = function () {
        return this.name = "scrawl_viewport", this.width = null, this.height = null, this.offsetX = null, this.offsetY = null, this.expectTouch = !1, this.canvas = !1, this.canvasGcoSourceIn = !1, this.canvasGcoSourceOut = !1, this.canvasGcoDestinationAtop = !1, this.canvasGcoDestinationIn = !1, this.canvasGcoCopy = !1, this.canvasEvenOddWinding = !1, this.canvasDashedLine = !1, this.getDeviceData(), this
    }, a.Device.prototype = Object.create(a.Base.prototype), a.Device.prototype.type = "Device", a.Device.prototype.classname = "objectnames", a.work.d.Device = {
        width: null,
        height: null,
        offsetX: null,
        offsetY: null,
        expectTouch: !1,
        canvas: !1,
        canvasEvenOddWinding: !1,
        canvasDashedLine: !1,
        canvasGcoSourceIn: !1,
        canvasGcoSourceOut: !1,
        canvasGcoDestinationAtop: !1,
        canvasGcoDestinationIn: !1,
        canvasGcoCopy: !1,
        video: !1,
        videoAutoplay: !1,
        videoForceFullScreen: !1
    }, a.mergeInto(a.work.d.Device, a.work.d.Base), a.Device.prototype.getDeviceData = function () {
        this.checkCanvas(), this.canvas && (this.checkCanvasEvenOddWinding(), this.checkCanvasDashedLine(), this.checkCanvasGco()), this.getViewportDimensions(), this.getViewportPosition(), this.getStacksDeviceData(), this.getImagesDeviceData(), this.checkTouch()
    }, a.Device.prototype.checkTouch = function () {
        var a = !1;
        "ontouchstart" in window ? a = !0 : window.DocumentTouch && document instanceof DocumentTouch && (a = !0), this.expectTouch = a
    }, a.Device.prototype.checkCanvas = function () {
        var a = document.createElement("canvas"),
            b = a.getContext("2d");
        this.canvas = b ? !0 : !1
    }, a.Device.prototype.checkCanvasEvenOddWinding = function () {
        var a, b = document.createElement("canvas"),
            c = b.getContext("2d"),
            d = "evenodd";
        b.width = 10, b.height = 10, c.beginPath(), c.moveTo(0, 0), c.lineTo(10, 0), c.lineTo(10, 10), c.lineTo(0, 10), c.lineTo(0, 0), c.moveTo(3, 3), c.lineTo(7, 3), c.lineTo(7, 7), c.lineTo(3, 7), c.lineTo(3, 3), c.moveTo(0, 0), c.closePath(), c.mozFillRule = d, c.msFillRule = d, c.fill(d), a = c.getImageData(5, 5, 1, 1), this.canvasEvenOddWinding = a.data[3] ? !1 : !0
    }, a.Device.prototype.checkCanvasDashedLine = function () {
        var a, b = document.createElement("canvas"),
            c = b.getContext("2d"),
            d = [5, 5];
        b.width = 10, b.height = 10, c.mozDash = d, c.lineDash = d;
        try {
            c.setLineDash(d)
        } catch (e) {}
        c.lineWidth = 10, c.beginPath(), c.moveTo(0, 5), c.lineTo(10, 5), c.stroke(), a = c.getImageData(8, 5, 1, 1), this.canvasDashedLine = a.data[3] ? !1 : !0
    }, a.Device.prototype.checkCanvasGco = function () {
        var a, b = document.createElement("canvas"),
            c = b.getContext("2d");
        b.width = 10, b.height = 10, c.fillStyle = "red", c.fillRect(3, 0, 4, 10), c.globalCompositeOperation = "source-in", c.fillStyle = "blue", c.fillRect(0, 3, 10, 4), a = c.getImageData(5, 1, 1, 1), this.canvasGcoSourceIn = a.data[3] ? !1 : !0, c.globalCompositeOperation = "source-over", c.clearRect(0, 0, 10, 10), c.fillStyle = "red", c.fillRect(3, 0, 4, 10), c.globalCompositeOperation = "source-out", c.fillStyle = "blue", c.fillRect(0, 3, 10, 4), a = c.getImageData(5, 1, 1, 1), this.canvasGcoSourceOut = a.data[3] ? !1 : !0, c.globalCompositeOperation = "source-over", c.clearRect(0, 0, 10, 10), c.fillStyle = "red", c.fillRect(3, 0, 4, 10), c.globalCompositeOperation = "destination-atop", c.fillStyle = "blue", c.fillRect(0, 3, 10, 4), a = c.getImageData(5, 1, 1, 1), this.canvasGcoDestinationAtop = a.data[3] ? !1 : !0, c.globalCompositeOperation = "source-over", c.clearRect(0, 0, 10, 10), c.fillStyle = "red", c.fillRect(3, 0, 4, 10), c.globalCompositeOperation = "destination-in", c.fillStyle = "blue", c.fillRect(0, 3, 10, 4), a = c.getImageData(5, 1, 1, 1), this.canvasGcoDestinationIn = a.data[3] ? !1 : !0, c.globalCompositeOperation = "source-over", c.clearRect(0, 0, 10, 10), c.fillStyle = "red", c.fillRect(3, 0, 4, 10), c.globalCompositeOperation = "copy", c.fillStyle = "blue", c.fillRect(0, 3, 10, 4), a = c.getImageData(5, 1, 1, 1), this.canvasGcoCopy = a.data[3] ? !1 : !0
    }, a.Device.prototype.getViewportDimensions = function (b) {
        var c, d, e;
        return b ? (c = a.device, d = c.width, e = c.height, c.width = document.documentElement.clientWidth - 1, c.height = document.documentElement.clientHeight - 1, d != c.width || e != c.height ? !0 : !1) : (d = this.width, e = this.height, this.width = document.documentElement.clientWidth - 1, this.height = document.documentElement.clientHeight - 1, d != this.width || e != this.height ? !0 : !1)
    }, a.Device.prototype.getViewportPosition = function (b) {
        var c, d, e, f, g;
        return b ? (c = a.device, d = a.xtGet, e = c.offsetX, f = c.offsetY, c.offsetX = d(b.pageX, b.target.offsetX, 0), c.offsetY = d(b.pageY, b.target.offsetY, 0), e != c.offsetX || f != c.offsetY ? !0 : !1) : (g = document.documentElement, e = this.offsetX, f = this.offsetY, this.offsetX = (window.pageXOffset || g.scrollLeft) - (g.clientLeft || 0), this.offsetY = (window.pageYOffset || g.scrollTop) - (g.clientTop || 0), e != this.offsetX || f != this.offsetY ? !0 : !1)
    }, a.Device.prototype.getStacksDeviceData = function () {}, a.Device.prototype.getImagesDeviceData = function () {}, a.Device.prototype.isLandscape = function () {
        return this.width < this.height ? !1 : !0
    }, a.Device.prototype.isPortrait = function () {
        return this.width < this.height ? !0 : !1
    }, a.Position = function (b) {
        var c = a.safeObject,
            d = a.work.d[this.type],
            e = a.xtGet,
            f = a.makeVector;
        a.Base.call(this, b), b = c(b);
        var g = c(b.start);
        return this.start = f({
            x: e(b.startX, g.x, 0),
            y: e(b.startY, g.y, 0),
            name: this.type + "." + this.name + ".start"
        }), this.currentStart = f({
            name: this.type + "." + this.name + ".current.start"
        }), this.currentStart.flag = !1, g = c(b.handle), this.handle = f({
            x: e(b.handleX, g.x, 0),
            y: e(b.handleY, g.y, 0),
            name: this.type + "." + this.name + ".handle"
        }), this.currentHandle = f({
            name: this.type + "." + this.name + ".current.handle"
        }), this.currentHandle.flag = !1, this.maxDimensions = {
            flag: !0,
            left: 0,
            right: 0,
            top: 0,
            bottom: 0
        }, this.pivot = e(b.pivot, d.pivot), this.scale = e(b.scale, d.scale), this.roll = e(b.roll, d.roll), this.flipReverse = e(b.flipReverse, d.flipReverse), this.flipUpend = e(b.flipUpend, d.flipUpend), this.lockX = e(b.lockX, d.lockX), this.lockY = e(b.lockY, d.lockY), this.mouseIndex = e(b.mouseIndex, "mouse"), this.animationPositionInit(b), this.pathPositionInit(b), this
    }, a.Position.prototype = Object.create(a.Base.prototype), a.Position.prototype.type = "Position", a.Position.prototype.classname = "objectnames", a.work.d.Position = {
        start: {
            x: 0,
            y: 0
        },
        currentStart: {
            x: 0,
            y: 0
        },
        handle: {
            x: 0,
            y: 0
        },
        currentHandle: {
            x: 0,
            y: 0
        },
        maxDimensions: {
            flag: !0,
            left: 0,
            right: 0,
            top: 0,
            bottom: 0
        },
        pivot: null,
        scale: 1,
        flipReverse: !1,
        flipUpend: !1,
        lockX: !1,
        lockY: !1,
        roll: 0,
        mouseIndex: "mouse",
        width: 0,
        height: 0
    }, a.mergeInto(a.work.d.Position, a.work.d.Base), a.Position.prototype.animationPositionInit = function () {}, a.Position.prototype.pathPositionInit = function () {}, a.Position.prototype.get = function (b) {
        var c = ["startX", "startY", "handleX", "handleY"];
        if (a.contains(c, b)) switch (b) {
            case "startX":
                return this.start.x;
            case "startY":
                return this.start.y;
            case "handleX":
                return this.handle.x;
            case "handleY":
                return this.handle.y
        }
        return this.animationPositionGet(b) || a.Base.prototype.get.call(this, b)
    }, a.Position.prototype.getX = function () {
        return this.currentStart.x
    }, a.Position.prototype.getY = function () {
        return this.currentStart.y
    }, a.Position.prototype.animationPositionGet = function () {
        return !1
    }, a.Position.prototype.set = function (b) {
        var c = a.xto;
        return b = a.safeObject(b), a.Base.prototype.set.call(this, b), c(b.start, b.startX, b.startY) && this.setStart(b), c(b.handle, b.handleX, b.handleY) && this.setHandle(b), c(b.flipUpend, b.flipReverse, b.scale, b.width, b.height, b.roll) && (this.maxDimensions.flag = !0, c(b.scale, b.width, b.height) && (this.currentHandle.flag = !1)), a.xt(b.pivot) && (this.currentPivotIndex = !1), this.animationPositionSet(b), this
    }, a.Position.prototype.setStart = function (b) {
        var c, d = a.safeObject,
            e = a.xtGet,
            f = a.makeVector,
            g = a.isa_vector;
        return b = d(b), g(this.start) || (this.start = f(b.start || this.start), this.start.name = this.type + "." + this.name + ".start"), c = d(b.start), this.start.x = e(b.startX, c.x, this.start.x), this.start.y = e(b.startY, c.y, this.start.y), g(this.currentStart) || (this.currentStart = f({
            name: this.type + "." + this.name + ".current.start"
        })), this.currentStart.flag = !1, this.maxDimensions.flag = !0, this
    }, a.Position.prototype.setHandle = function (b) {
        var c, d = a.safeObject,
            e = a.xtGet,
            f = a.makeVector,
            g = a.isa_vector;
        return b = d(b), g(this.handle) || (this.handle = f(b.handle || this.handle), this.handle.name = this.type + "." + this.name + ".handle"), c = d(b.handle), this.handle.x = e(b.handleX, c.x, this.handle.x), this.handle.y = e(b.handleY, c.y, this.handle.y), g(this.currentHandle) || (this.currentHandle = f({
            name: this.type + "." + this.name + ".current.handle"
        })), this.currentHandle.flag = !1, this.maxDimensions.flag = !0, this
    }, a.Position.prototype.animationPositionSet = function () {}, a.Position.prototype.updateStart = function () {}, a.Position.prototype.revertStart = function () {}, a.Position.prototype.reverse = function () {}, a.Position.prototype.setDeltaAttribute = function () {}, a.Position.prototype.setDelta = function (b) {
        var c = a.xto;
        return b = a.safeObject(b), c(b.start, b.startX, b.startY) && this.setDeltaStart(b), a.Position.prototype.pathPositionSetDelta.call(this, b), c(b.handle, b.handleX, b.handleY) && this.setDeltaHandle(b), c(b.scale, b.width, b.height, b.roll) && (b.scale && this.setDeltaScale(b), b.roll && this.setDeltaRoll(b), b.width && this.setDeltaWidth(b), b.height && this.setDeltaHeight(b), this.maxDimensions.flag = !0, c(b.scale, b.width, b.height) && (this.currentHandle.flag = !1)), this
    }, a.Position.prototype.setDeltaStart = function (b) {
        var c, d, e, f = a.safeObject,
            g = a.xtGet,
            h = a.addPercentages;
        return b = f(b), c = f(b.start), d = g(b.startX, c.x, 0), e = g(b.startY, c.y, 0), this.start.x = this.start.x.toFixed ? this.start.x + d : h(this.start.x, d), this.start.y = this.start.y.toFixed ? this.start.y + e : h(this.start.y, e), this.currentStart.flag = !1, this
    }, a.Position.prototype.setDeltaHandle = function (b) {
        var c, d, e, f = a.safeObject,
            g = a.xtGet,
            h = a.addPercentages;
        return b = f(b), c = f(b.handle), d = g(b.handleX, c.x, 0), e = g(b.handleY, c.y, 0), this.handle.x = this.handle.x.toFixed ? this.handle.x + d : h(this.handle.x, d), this.handle.y = this.handle.y.toFixed ? this.handle.y + e : h(this.handle.y, e), this.currentHandle.flag = !1, this
    }, a.Position.prototype.setDeltaScale = function (b) {
        return b = a.safeObject(b), this.scale += b.scale || 0, this
    }, a.Position.prototype.setDeltaRoll = function (b) {
        return b = a.safeObject(b), this.roll += b.roll || 0, this
    }, a.Position.prototype.setDeltaWidth = function (b) {
        var c;
        return b = a.safeObject(b), c = b.width || 0, this.width = this.width.toFixed ? this.width + c : a.addPercentages(this.width, c), this
    }, a.Position.prototype.setDeltaHeight = function (b) {
        var c;
        return b = a.safeObject(b), c = b.height || 0, this.height = this.height.toFixed ? this.height + c : a.addPercentages(this.height, c), this
    }, a.Position.prototype.pathPositionSetDelta = function () {}, a.Position.prototype.clone = function (b) {
        var c, d, e = a.safeObject,
            f = a.makeVector,
            g = a.xtGet;
        return b = e(b), d = a.Base.prototype.clone.call(this, b), c = e(b.start), d.start = f({
            x: g(b.startX, c.x, d.start.x),
            y: g(b.startY, c.y, d.start.y),
            name: d.type + "." + d.name + ".start"
        }), c = e(b.handle), d.handle = f({
            x: g(b.handleX, c.x, d.handle.x),
            y: g(b.handleY, c.y, d.handle.y),
            name: d.type + "." + d.name + ".handle"
        }), d = this.animationPositionClone(d, b)
    }, a.Position.prototype.animationPositionClone = function (a) {
        return a
    }, a.Position.prototype.getReferenceDimensions = {
        Pad: function (a) {
            return {
                w: a.localWidth,
                h: a.localHeight,
                c: !1
            }
        },
        Cell: function (a) {
            return {
                w: a.actualWidth,
                h: a.actualHeight,
                c: !1
            }
        },
        Block: function (a) {
            var b = a.scale;
            return {
                w: a.localWidth / b,
                h: a.localHeight / b,
                c: !1
            }
        },
        Wheel: function (a) {
            return {
                w: a.width,
                h: a.height,
                c: !0
            }
        },
        Phrase: function (a) {
            return {
                w: a.width,
                h: a.height,
                c: !1
            }
        },
        Picture: function (a) {
            var b = a.scale,
                c = a.pasteData;
            return {
                w: c.w / b,
                h: c.h / b,
                c: !1
            }
        },
        Path: function (a) {
            return {
                w: a.width,
                h: a.height,
                c: a.isLine ? !1 : !0
            }
        },
        Shape: function (a) {
            return {
                w: a.width,
                h: a.height,
                c: a.isLine ? !1 : !0
            }
        },
        Frame: function (a) {
            return {
                w: a.width,
                h: a.height,
                c: !1
            }
        }
    }, a.Position.prototype.updateCurrentHandle = function () {
        var b, c, d, e, f, g, h, i, j;
        return this.currentHandle.flag || (b = this.getReferenceDimensions[this.type](this), c = a.contains, d = this.numberConvert, e = this.handle, f = ["top", "bottom", "left", "right", "center"], g = e.x.substring, h = e.y.substring, i = this.currentHandle, j = this.scale || 1, i.x = g ? d(e.x, b.w) : e.x, i.y = h ? d(e.y, b.h) : e.y, b.c && (c(f, e.x) && (i.x -= b.w / 2), c(f, e.y) && (i.y -= b.h / 2)), g && (i.x *= j), h && (i.y *= j), isNaN(i.x) && (i.x = 0), isNaN(i.y) && (i.y = 0), i.reverse(), i.flag = !0), this
    }, a.Position.prototype.updateCurrentStart = function (a) {
        var b, c, d, e;
        if (!this.currentStart.flag && a && a.type) {
            if (e = this.currentStart, b = this.getReferenceDimensions[a.type](a), c = this.numberConvert, d = this.start, e.x = d.x.substring ? c(d.x, b.w) : d.x, e.y = d.y.substring ? c(d.y, b.h) : d.y, isNaN(e.x) || isNaN(e.y)) return e.x = 0, e.y = 0, this;
            e.flag = !0
        }
        return this
    }, a.Position.prototype.setStampUsingPivot = function (b, c) {
        var d, e, f, g, h, i, j, k = this.setStampUsingPivotCalculations;
        return this.currentPivotIndex || (f = this.pivot, g = a.point, h = a.entity, i = a.safeObject, "mouse" === f ? (d = "mouse", e = !1) : i(g)[f] ? (d = "point", e = g[f]) : h[f] ? (d = "entity", e = h[f]) : (j = a.xtGet(i(a.stack)[f], i(a.pad)[f], i(a.element)[f], !1), j && (d = "stack", e = j)), d && (this.currentPivot = e, this.currentPivotIndex = d)), this.currentPivotIndex && k[this.currentPivotIndex](this, this.currentPivot, b, c), this
    }, a.Position.prototype.setStampUsingPivotCalculations = {
        point: function (b, c) {
            var d = a.entity[c.entity],
                e = b.currentStart,
                f = c.getCurrentCoordinates().rotate(d.roll).vectorAdd(d.currentStart);
            e.x = b.lockX ? e.x : f.x, e.y = b.lockY ? e.y : f.y
        },
        entity: function (a, b) {
            var c = "Particle" === b.type ? b.get("place") : b.currentStart,
                d = a.currentStart;
            d.x = a.lockX ? d.x : c.x, d.y = a.lockY ? d.y : c.y
        },
        mouse: function (b, c, d, e) {
            var f, g = b.currentStart;
            a.xt(e) || (d = a.cell[d], f = a.pad[d.pad], e = f.mice[b.mouseIndex]), e = b.correctCoordinates(e, d), e && (null == b.oldX && null == b.oldY && (b.oldX = g.x, b.oldY = g.y), g.x = b.lockX ? g.x : g.x + e.x - b.oldX, g.y = b.lockY ? g.y : g.y + e.y - b.oldY, b.oldX = e.x, b.oldY = e.y)
        },
        stack: function () {}
    }, a.Position.prototype.correctCoordinates = function (b, c) {
        var d, e, f, g, h = a.xtGet;
        return b = a.safeObject(b), d = a.work.v.set(b), scrawl.xta(b.x, b.y) ? (c = a.cell[c] ? a.cell[c] : a.cell[a.pad[a.work.currentPad].base], e = a.pad[c.pad], f = h(e.localWidth, e.width, 300), g = h(e.localHeight, e.height, 150), f !== c.actualWidth && (d.x /= f / c.actualWidth), g !== c.actualHeight && (d.y /= g / c.actualHeight), d) : !1
    }, a.PageElement = function (b) {
        var c = a.xtGet,
            d = a.work.d[this.type];
        return b = a.safeObject(b), a.Base.call(this, b), this.width = c(b.width, d.width), this.height = c(b.height, d.height), this.scale = c(b.scale, d.scale), this.propogateTouch = c(b.propogateTouch, d.propogateTouch), this.setLocalDimensions(), this.stacksPageElementConstructor(b), this.mice = {
            mouse: a.makeVector()
        }, this.mice.mouse.id = "mouse", this.mice.mouse.active = !1, this.mice.mouse.name = this.type + "." + this.name + ".ui.mouse", this
    }, a.PageElement.prototype = Object.create(a.Base.prototype), a.PageElement.prototype.type = "PageElement", a.PageElement.prototype.classname = "objectnames", a.work.d.PageElement = {
        width: 300,
        height: 150,
        localWidth: 300,
        localHeight: 150,
        displayOffsetX: 0,
        displayOffsetY: 0,
        scale: 1,
        mice: {},
        interactive: !0,
        propogateTouch: !1,
        position: "static"
    }, a.mergeInto(a.work.d.PageElement, a.work.d.Base), a.PageElement.prototype.stacksPageElementConstructor = function () {}, a.PageElement.prototype.get = function (b) {
        var c = this.getElement(),
            d = ["width", "height", "position"],
            e = a.xtGet,
            f = a.work.d[this.type];
        if (a.contains(d, b)) switch (b) {
            case "width":
                return e(this.localWidth, parseFloat(c.width), f.width);
            case "height":
                return e(this.localHeight, parseFloat(c.height), f.height);
            case "position":
                return e(this.position, c.style.position)
        }
        return a.Base.prototype.get.call(this, b)
    }, a.PageElement.prototype.set = function (b) {
        var c = a.xt,
            d = a.xto;
        return b = a.safeObject(b), a.Base.prototype.set.call(this, b), d(b.width, b.height, b.scale) && (this.setLocalDimensions(), this.setDimensions(), this.setDisplayOffsets()), c(b.position) && (this.position = b.position), c(b.pivot) && (this.pivot = b.pivot, this.pivot || (delete this.oldX, delete this.oldY)), c(b.mouse) && this.initMouse(b.mouse), d(b.title, b.comment) && this.setAccessibility(b), c(b.interactive) && (this.interactive = b.interactive, this.removeMouseMove(), this.interactive && this.addMouseMove()), this
    }, a.PageElement.prototype.setAccessibility = function (b) {
        var c, d = a.xt;
        return b = a.safeObject(b), c = this.getElement(), d(b.title) && (this.title = b.title, c.title = this.title), d(b.comment) && (this.comment = b.comment, c.setAttribute("data-comment", this.comment)), this
    }, a.PageElement.prototype.setDisplayOffsets = function () {
        var a = this.getElement(),
            b = 0,
            c = 0;
        if (a.offsetParent)
            do b += a.offsetLeft, c += a.offsetTop, a = a.offsetParent; while (a.offsetParent);
        return this.displayOffsetX = b, this.displayOffsetY = c, this
    }, a.PageElement.prototype.scaleDimensions = function (a) {
        return a.toFixed && (this.scale = a, this.setDimensions()), this
    }, a.PageElement.prototype.setLocalDimensions = function () {
        var a = this.scale;
        return this.localWidth = this.width * a, this.localHeight = this.height * a, this
    }, a.PageElement.prototype.setDimensions = function () {
        var a = this.getElement();
        return a.style.width = this.localWidth + "px", a.style.height = this.localHeight + "px", this
    }, a.PageElement.prototype.getMouse = function (b) {
        var c, d, e, f = [];
        if (a.xt(b)) {
            if (a.xt(b) && a.isa_bool(b) && b) return this.mice;
            if (a.isa_event(b)) {
                if (b.changedTouches) {
                    for (d = 0, e = b.changedTouches.length; e > d; d++) c = "t" + b.changedTouches[d].identifier, f.push(this.mice[c]);
                    return f
                }
                return b.pointerType ? (c = "touch" !== b.pointerType ? b.pointerType : "p" + b.pointerId, [this.mice[c]]) : [this.mice.mouse]
            }
            return [this.mice.mouse]
        }
        return a.xtGet(this.mice.t0, this.mice.p1, this.mice.pen, this.mice.mouse)
    }, a.PageElement.prototype.getMouseIdFromEvent = function (b) {
        var c, d, e, f = [];
        if (a.isa_event(b))
            if (b.changedTouches)
                for (d = 0, e = b.changedTouches.length; e > d; d++) c = "t" + b.changedTouches[d].identifier, f.push(c);
            else b.pointerType ? (c = "touch" !== b.pointerType ? b.pointerType : "p" + b.pointerId, f.push(c)) : f.push("mouse");
        return f
    }, a.PageElement.prototype.handleMouseMove = function (b) {
        var c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u = a.pad,
            v = a.stack,
            w = a.element,
            x = a.work.activeListeners,
            y = a.xt,
            z = a.makeVector,
            A = this.id;
        if (y(A) ? (g = u[A] || v[A] || w[A] || !1, l = this) : (g = this, l = this.getElement()), b.changedTouches)
            for (m = b.changedTouches, h = 0, i = m.length; i > h; h++) {
                if (o = "t" + m[h].identifier, "touchstart" === b.type)
                    for (j = 0, k = x.length; k > j; j++) q = u[x[j]] || v[x[j]] || w[x[j]] || !1, q && delete q.mice[o];
                if (y(g.mice[o]) || (g.mice[o] = z({
                        name: g.type + "." + g.name + ".t." + o
                    }), g.mice[o].active = null, g.mice[o].id = o), m[h].pageX || m[h].pageY ? (c = m[h].pageX, d = m[h].pageY) : (m[h].clientX || m[h].clientY) && (c = m[h].clientX + document.body.scrollLeft + document.documentElement.scrollLeft, d = m[h].clientY + document.body.scrollTop + document.documentElement.scrollTop), e = g.displayOffsetX + g.localWidth, f = g.displayOffsetY + g.localHeight, this.propogateTouch && "touchmove" === b.type)
                    for (j = 0, k = x.length; k > j; j++) this.name !== x[j] && (p = a.canvas[x[j]] || a.stk[x[j]] || a.elm[x[j]] || !1, p && a.triggerTouchFollow(b, p));
                n = c >= g.displayOffsetX && e >= c && d >= g.displayOffsetY && f >= d ? !0 : !1, g.mice[o].active !== n && (g.mice[o].active = n, ("touchmove" === b.type || "touchfollow" === b.type) && (n ? a.triggerTouchEnter(b, l) : a.triggerTouchLeave(b, l))), g.mice[o].x = c - g.displayOffsetX, g.mice[o].y = d - g.displayOffsetY, "Pad" === g.type && (g.mice[o].x = Math.round(g.mice[o].x / g.scale || 1), g.mice[o].y = Math.round(g.mice[o].y / g.scale || 1)), ("touchup" === b.type || "touchleave" === b.type) && (g.mice[o].x = null, g.mice[o].y = null)
            } else b.pointerType ? (s = b.target.id, o = "touch" !== b.pointerType ? b.pointerType : "p" + b.pointerId, y(g.mice[o]) || (g.mice[o] = z({
                name: g.type + "." + g.name + ".p." + o
            }), g.mice[o].active = null, g.mice[o].id = o), t = g.mice[o], s === g.name ? (t.active = !1, b.offsetX >= 0 && b.offsetX <= g.localWidth && b.offsetY >= 0 && b.offsetY <= g.localHeight && (t.active = !0), t.x = Math.round(b.offsetX), t.y = Math.round(b.offsetY), "Pad" === g.type && (t.x = Math.round(t.x / (g.scale || 1)), t.y = Math.round(t.y / (g.scale || 1)))) : s && (r = b.target.parentNode, r.id === g.name && (t.x = Math.round(b.pageX - g.displayOffsetX), t.y = Math.round(b.pageY - g.displayOffsetY), t.active = !1, t.x >= 0 && t.x <= g.localWidth && t.y >= 0 && t.y <= g.localHeight && (t.active = !0), "Pad" === g.type && (t.x = Math.round(t.x / (g.scale || 1)), t.y = Math.round(t.y / (g.scale || 1)))))) : (y(g.mice.mouse) || (g.mice.mouse = z({
                name: g.type + "." + g.name + ".ui.mouse"
            }), g.mice.mouse.active = null, g.mice.mouse.id = "mouse"), b.pageX || b.pageY ? (c = b.pageX, d = b.pageY) : (b.clientX || b.clientY) && (c = b.clientX + document.body.scrollLeft + document.documentElement.scrollLeft, d = b.clientY + document.body.scrollTop + document.documentElement.scrollTop), g.mice.mouse.active = !0, "mouseleave" === b.type && (g.mice.mouse.active = !1), g.mice.mouse.x = c - g.displayOffsetX, g.mice.mouse.y = d - g.displayOffsetY, "Pad" === g.type && (g.mice.mouse.x = Math.round(g.mice.mouse.x / (g.scale || 1)), g.mice.mouse.y = Math.round(g.mice.mouse.y / (g.scale || 1))));
        return g.handleMouseTilt(b), g
    }, a.PageElement.prototype.pickupEntity = function () {}, a.PageElement.prototype.dropEntity = function () {}, a.PageElement.prototype.handleMouseTilt = function () {}, a.PageElement.prototype.addMouseMove = function () {
        var b = this.getElement();
        return a.addListener(["up", "down", "move", "enter", "leave"], this.handleMouseMove, b), this.propogateTouch && a.pushUnique(a.work.activeListeners, this.name), this
    }, a.PageElement.prototype.removeMouseMove = function () {
        var b = this.getElement();
        return a.removeListener(["up", "down", "move", "enter", "leave"], this.handleMouseMove, b), this.propogateTouch && a.removeItem(a.work.activeListeners, this.name), this
    }, a.Pad = function (b) {
        var c, d, e, f = a.xtGet,
            g = a.work.d.Pad,
            h = a.pushUnique,
            i = a.makeCell;
        return b = a.safeObject(b), a.isa_canvas(b.canvasElement) ? (b.width = f(b.width, b.canvasElement.width, g.width), b.height = f(b.height, b.canvasElement.height, g.height), b.name = f(b.name, b.canvasElement.id, b.canvasElement.name, "Pad"), a.PageElement.call(this, b), this.name.match(/___/) && (this.name = this.name.replace(/___/g, "_")), b.canvasElement.id = this.name, a.pad[this.name] = this, h(a.padnames, this.name), this.cells = [], c = i({
            name: this.name,
            pad: this.name,
            canvas: b.canvasElement,
            compiled: !1,
            shown: !1,
            width: this.localWidth,
            height: this.localHeight
        }), h(this.cells, c.name), this.display = c.name, e = b.canvasElement.cloneNode(!0), e.setAttribute("id", this.name + "_base"), d = i({
            name: this.name + "_base",
            pad: this.name,
            canvas: e,
            compileOrder: 9999,
            shown: !1,
            width: "100%",
            height: "100%"
        }), h(this.cells, d.name), this.base = d.name, this.current = d.name, this.setDisplayOffsets(), this.setAccessibility(b), this.filtersPadInit(), this.padStacksConstructor(b), this.interactive = f(b.interactive, !0), this.interactive && this.addMouseMove(), this.cellsCompileOrder = [].concat(this.cells), this.cellsShowOrder = [].concat(this.cells), this.resortCompile = !0, this.resortShow = !0, this) : !1
    }, a.Pad.prototype = Object.create(a.PageElement.prototype), a.Pad.prototype.type = "Pad", a.Pad.prototype.classname = "padnames", a.work.d.Pad = {
        cells: [],
        display: "",
        base: "",
        current: ""
    }, a.mergeInto(a.work.d.Pad, a.work.d.PageElement), a.Pad.prototype.getElement = function () {
        return a.canvas[this.display]
    }, a.Pad.prototype.filtersPadInit = function () {}, a.Pad.prototype.stacksPadInit = function () {}, a.Pad.prototype.set = function (b) {
        var c, d, e = a.cell,
            f = a.xto;
        return a.PageElement.prototype.set.call(this, b), b = a.safeObject(b), d = e[this.display], c = e[this.base], f(b.scale, b.width, b.height) && (d.set({
            pasteWidth: b.width ? this.localWidth : d.pasteWidth,
            pasteHeight: b.height ? this.localHeight : d.pasteHeight,
            scale: b.scale || d.scale
        }), c.set({
            scale: b.scale || c.scale
        })), this.padStacksSet(b), f(b.start, b.startX, b.startY, b.handle, b.handleX, b.handleY, b.scale, b.width, b.height) && this.setDisplayOffsets(), f(b.backgroundColor, b.globalAlpha, b.globalCompositeOperation) && c.set({
            backgroundColor: b.backgroundColor || c.backgroundColor,
            globalAlpha: b.globalAlpha || c.globalAlpha,
            globalCompositeOperation: b.globalCompositeOperation || c.globalCompositeOperation
        }), this
    }, a.Pad.prototype.padStacksConstructor = function () {}, a.Pad.prototype.padStacksSet = function () {}, a.Pad.prototype.sortCellsCompile = function () {
        this.resortCompile && (this.resortCompile = !1, this.cellsCompileOrder = a.bucketSort("cell", "compileOrder", this.cellsCompileOrder))
    }, a.Pad.prototype.sortCellsShow = function () {
        this.resortShow && (this.resortShow = !1, this.cellsShowOrder = a.bucketSort("cell", "showOrder", this.cellsShowOrder))
    }, a.Pad.prototype.clear = function () {
        var b, c, d, e = this.cells,
            f = a.cell;
        for (c = 0, d = e.length; d > c; c++) b = f[e[c]], b.rendered && b.cleared && b.clear();
        return this
    }, a.Pad.prototype.compile = function (b) {
        var c, d, e, f = a.cell,
            g = this.cellsCompileOrder;
        for (this.sortCellsCompile(), d = 0, e = g.length; e > d; d++) c = f[g[d]], c.rendered && c.compiled && c.compile(b);
        return this
    }, a.Pad.prototype.show = function () {
        var b, c, d, e, f, g = a.cell,
            h = this.cellsShowOrder;
        for (b = g[this.display], c = g[this.base], this.sortCellsShow(), e = 0, f = h.length; f > e; e++) d = g[h[e]], d.rendered && d.shown && c.copyCellToSelf(d);
        return b.copyCellToSelf(c, !0), this
    }, a.Pad.prototype.render = function (a) {
        return this.clear(), this.compile(a), this.show(), this
    }, a.Pad.prototype.addNewCell = function (b) {
        var c, d, e = a.pushUnique;
        return b = a.safeObject(b), b.name.substring ? (b.width = Math.round(b.width) || this.width, b.height = Math.round(b.height) || this.height, c = document.createElement("canvas"), c.setAttribute("id", b.name), c.setAttribute("height", b.height), c.setAttribute("width", b.width), b.pad = this.name, b.canvas = c, d = a.makeCell(b), e(this.cells, d.name), e(this.cellsCompileOrder, d.name), e(this.cellsShowOrder, d.name), this.resortCompile = !0, this.resortShow = !0, d) : !1
    }, a.Pad.prototype.addCells = function () {
        var b, c, d, e = a.pushUnique;
        for (b = Array.prototype.slice.call(arguments), Array.isArray(b[0]) && (b = b[0]), c = 0, d = b.length; d > c; c++) a.cell[b[c]] && (e(this.cells, b[c]), e(this.cellsCompileOrder, b[c]), e(this.cellsShowOrder, b[c]));
        return this.resortCompile = !0, this.resortShow = !0, this
    }, a.Pad.prototype.deleteCell = function (b) {
        var c = a.removeItem;
        return b.substring ? (c(this.cells, b), c(this.cellsCompileOrder, b), c(this.cellsShowOrder, b), this.display === b && (this.display = this.current), this.base === b && (this.base = this.current), this.current === b && (this.current = this.base), this.resortCompile = !0, this.resortShow = !0, this) : this
    }, a.Pad.prototype.makeCurrent = function () {
        return a.work.currentPad = this.name, this
    }, a.Pad.prototype.setAccessibility = function (b) {
        var c, d = a.xt;
        return b = a.safeObject(b), c = this.getElement(), d(b.title) && (this.title = b.title, c.title = this.title), d(b.comment) && (this.comment = b.comment, c.setAttribute("data-comment", this.comment), c.innerHTML = "<p>" + this.comment + "</p>"), this
    }, a.Pad.prototype.setDimensions = function () {
        var a = this.getElement();
        return a.width = this.localWidth, a.height = this.localHeight, this
    }, a.Cell = function (b) {
        return b = a.safeObject(b), a.xta(b, b.canvas) ? (this.coreCellInit(b), this.animationCellInit(b), this.collisionsCellInit(b), this.filtersCellInit(b), this) : !1
    }, a.Cell.prototype = Object.create(a.Position.prototype), a.Cell.prototype.type = "Cell", a.Cell.prototype.classname = "cellnames", a.work.d.Cell = {
        pad: "",
        copy: {
            x: 0,
            Y: 0
        },
        copyWidth: 300,
        copyHeight: 150,
        copyData: !1,
        pasteData: !1,
        pasteWidth: 300,
        pasteHeight: 150,
        actualWidth: 300,
        actualHeight: 150,
        fieldLabel: "",
        globalAlpha: 1,
        globalCompositeOperation: "source-over",
        backgroundColor: "rgba(0,0,0,0)",
        context: "",
        groups: [],
        rendered: !0,
        cleared: !0,
        compiled: !0,
        shown: !0,
        compileOrder: 0,
        showOrder: 0
    }, a.mergeInto(a.work.d.Cell, a.work.d.Position), a.Cell.prototype.coreCellInit = function (b) {
        var c, d, e, f = a.work.d.Cell,
            g = a.xt,
            h = a.xto,
            i = a.xtGet,
            j = a.makeVector;
        a.Position.call(this, b), a.Base.prototype.set.call(this, b), a.canvas[this.name] = b.canvas, e = a.canvas[this.name], a.context[this.name] = b.canvas.getContext("2d"), a.cell[this.name] = this, a.pushUnique(a.cellnames, this.name), this.pad = i(b.pad, !1), c = a.safeObject(b.copy), this.copy = j({
            x: i(b.copyX, c.x, 0),
            y: i(b.copyY, c.y, 0),
            name: this.type + "." + this.name + ".copy"
        }), this.actualWidth = e.width, this.actualHeight = e.height, this.copyWidth = this.actualWidth, this.copyHeight = this.actualHeight, this.copyData = {
            x: 0,
            y: 0,
            w: 0,
            h: 0
        }, this.pasteData = {
            x: 0,
            y: 0,
            w: 0,
            h: 0
        }, this.pasteWidth = this.actualWidth, this.pasteHeight = this.actualHeight, this.setDimensions(b), h(b.pasteX, b.pasteY) && (this.start.x = i(b.pasteX, this.start.x), this.start.y = i(b.pasteY, this.start.y)), h(b.copyWidth, b.copyHeight, b.pasteWidth, b.pasteHeight, b.width, b.height) && (this.copyWidth = i(b.copyWidth, b.width, this.copyWidth), this.copyHeight = i(b.copyHeight, b.height, this.copyHeight), this.pasteWidth = i(b.pasteWidth, b.width, this.pasteWidth), this.pasteHeight = i(b.pasteHeight, b.height, this.pasteHeight)), d = a.makeContext({
            name: this.name,
            cell: a.context[this.name]
        }), this.context = d.name, this.flipUpend = i(b.flipUpend, f.flipUpend), this.flipReverse = i(b.flipReverse, f.flipReverse), this.lockX = i(b.lockX, f.lockX), this.lockY = i(b.lockY, f.lockY), this.roll = i(b.roll, f.roll), this.rendered = i(b.rendered, !0), this.cleared = i(b.cleared, !0), this.compiled = i(b.compiled, !0), this.shown = i(b.shown, !0), this.compileOrder = i(b.compileOrder, 0), this.showOrder = i(b.showOrder, 0), this.backgroundColor = i(b.backgroundColor, "rgba(0,0,0,0)"), this.globalCompositeOperation = i(b.globalCompositeOperation, "source-over"), this.globalAlpha = i(b.globalAlpha, 1), this.groups = g(b.groups) ? [].concat(b.groups) : [], this.sortGroups = !0, a.makeGroup({
            name: this.name,
            cell: this.name
        }), this.setCopy(), this.setPaste()
    }, a.Cell.prototype.collisionsCellInit = function () {}, a.Cell.prototype.filtersCellInit = function () {}, a.Cell.prototype.animationCellInit = function () {}, a.Cell.prototype.get = function (b) {
        var c = ["pasteX", "pasteY", "copyX", "copyY"],
            d = ["paste", "copy"],
            e = ["width", "height"],
            f = a.contains;
        if (f(c, b)) switch (b) {
            case "pasteX":
                return this.start.x;
            case "pasteY":
                return this.start.y;
            case "copyX":
                return this.copy.x;
            case "copyY":
                return this.copy.y
        }
        if (f(d, b)) switch (b) {
            case "paste":
                return this.start.getVector();
            case "copy":
                return this.copy.getVector()
        }
        if (f(e, b)) switch (b) {
            case "width":
                return this.actualWidth;
            case "height":
                return this.actualHeight
        }
        return this.animationCellGet(b) || a.Position.prototype.get.call(this, b)
    }, a.Cell.prototype.animationCellGet = function () {
        return !1
    }, a.Cell.prototype.set = function (b) {
        var c = a.xt,
            d = a.xto;
        return a.Position.prototype.set.call(this, b), b = a.safeObject(b), d(b.paste, b.pasteX, b.pasteY) && this.setPasteVector(b, !1), d(b.copy, b.copyX, b.copyY) && this.setCopyVector(b), d(b.copyWidth, b.width) && this.setCopyWidth(b), d(b.copyHeight, b.height) && this.setCopyHeight(b), d(b.pasteWidth, b.width) && this.setPasteWidth(b, !1), d(b.pasteHeight, b.height) && this.setPasteHeight(b, !1), d(b.actualWidth, b.width) && this.setActualWidth(b, !1), d(b.actualHeight, b.height) && this.setActualHeight(b, !1), d(b.actualWidth, b.actualHeight, b.width, b.height) && (this.setDimensions(b), a.ctx[this.context].getContextFromEngine(a.context[this.name])), d(b.actualWidth, b.actualHeight, b.pasteWidth, b.pasteHeight, b.width, b.height, b.handle, b.handleX, b.handleY, b.scale) && this.setDirtyHandles(), d(b.handle, b.handleX, b.handleY, b.scale) && this.setDirtyHandles(), d(b.start, b.startX, b.startY, b.paste, b.pasteX, b.pasteY) && this.setDirtyStarts(), this.animationCellSet(b), c(b.compileOrder) && (a.pad[this.pad].resortCompile = !0), c(b.showOrder) && (a.pad[this.pad].resortShow = !0), b.resolve && (this.setCopy(), this.setPaste()), this
    }, a.Cell.prototype.setDirtyStarts = function () {
        var b, c, d, e = a.group,
            f = this.groups;
        for (c = 0, d = f.length; d > c; c++) b = f[c], e[b] && e[b].setDirtyStarts();
        return this.currentStart.flag = !1, this
    }, a.Cell.prototype.setDirtyHandles = function () {
        var b, c, d, e = a.group,
            f = this.groups;
        for (c = 0, d = f.length; d > c; c++) b = f[c], e[b] && e[b].setDirtyHandles();
        return this.currentHandle.flag = !1, this
    }, a.Cell.prototype.setActualHeight = function (b, c) {
        var d = a.xtGet;
        return b = a.safeObject(b), c = d(c, !0), this.actualHeight = d(b.actualHeight, b.height, this.actualHeight), c && (this.setDimensions(b), a.ctx[this.context].getContextFromEngine(a.context[this.name]), this.setDirtyHandles()), this
    }, a.Cell.prototype.setActualWidth = function (b, c) {
        var d = a.xtGet;
        return b = a.safeObject(b), c = d(c, !0), this.actualWidth = d(b.actualWidth, b.width, this.actualWidth), c && (this.setDimensions(b), a.ctx[this.context].getContextFromEngine(a.context[this.name]), this.setDirtyHandles()), this
    }, a.Cell.prototype.setPasteHeight = function (b, c) {
        var d = a.xtGet;
        return b = a.safeObject(b), c = d(c, !0), this.pasteHeight = d(b.pasteHeight, b.height, this.pasteHeight), c && this.setDirtyHandles(), this
    }, a.Cell.prototype.setPasteWidth = function (b, c) {
        var d = a.xtGet;
        return b = a.safeObject(b), c = d(c, !0), this.pasteWidth = d(b.pasteWidth, b.width, this.pasteWidth), c && this.setDirtyHandles(), this
    }, a.Cell.prototype.setCopyHeight = function (b) {
        var c = a.xtGet;
        return b = a.safeObject(b), this.copyHeight = c(b.copyHeight, b.height, this.copyHeight), this
    }, a.Cell.prototype.setCopyWidth = function (b) {
        var c = a.xtGet;
        return b = a.safeObject(b), this.copyWidth = c(b.copyWidth, b.width, this.copyWidth), this
    }, a.Cell.prototype.setPasteVector = function (b, c) {
        var d, e = a.xtGet,
            f = a.safeObject,
            g = this.start;
        return b = f(b), c = e(c, !0), d = f(b.paste), g.x = e(b.pasteX, d.x, g.x), g.y = e(b.pasteY, d.y, g.y), c && this.setDirtyStarts(), this
    }, a.Cell.prototype.setCopyVector = function (b) {
        var c, d = a.xtGet,
            e = a.safeObject,
            f = this.copy;
        return b = e(b), c = e(b.copy), f.x = d(b.copyX, c.x, f.x), f.y = d(b.copyY, c.y, f.y), this
    }, a.Cell.prototype.animationCellSet = function () {}, a.Cell.prototype.setDelta = function (b) {
        var c = a.xt,
            d = a.xto;
        return a.Position.prototype.setDelta.call(this, b), b = a.safeObject(b), d(b.copy, b.copyX, b.copyY) && this.setDeltaCopy(b), d(b.paste, b.pasteX, b.pasteY) && this.setDeltaPaste(b, !1), c(b.copyWidth) && this.setDeltaCopyWidth(b), c(b.copyHeight) && this.setDeltaCopyHeight(b), d(b.pasteWidth, b.width) && this.setDeltaPasteWidth(b, !1), d(b.pasteHeight, b.height) && this.setDeltaPasteHeight(b, !1), d(b.actualWidth, b.width) && this.setDeltaActualWidth(b, !1), d(b.actualHeight, b.height) && this.setDeltaActualHeight(b, !1), c(b.roll) && this.setDeltaRoll(b), c(b.globalAlpha) && this.setDeltaGlobalAlpha(b), d(b.actualWidth, b.width, b.actualHeight, b.height) && (this.setDimensions(b), a.ctx[this.context].getContextFromEngine(a.context[this.name])), d(b.actualWidth, b.actualHeight, b.pasteWidth, b.pasteHeight, b.width, b.height, b.handle, b.handleX, b.handleY, b.scale) && this.setDirtyHandles(), d(b.start, b.startX, b.startY, b.paste, b.pasteX, b.pasteY) && this.setDirtyStarts(), b.resolve && (this.setCopy(), this.setPaste()), this
    }, a.Cell.prototype.setDeltaGlobalAlpha = function (b) {
        return b = a.safeObject(b), this.globalAlpha += b.globalAlpha || 0, this
    }, a.Cell.prototype.setDeltaRoll = function (b) {
        return b = a.safeObject(b), this.roll += b.roll || 0, this
    }, a.Cell.prototype.setDeltaActualHeight = function (b, c) {
        var d, e = a.xtGet;
        return b = a.safeObject(b), c = e(c, !0), d = e(b.actualHeight, b.height), this.actualHeight = d.toFixed ? this.actualHeight + d : this.actualHeight, c && (this.setDimensions(b), a.ctx[this.context].getContextFromEngine(a.context[this.name]), this.setDirtyHandles()), this
    }, a.Cell.prototype.setDeltaActualWidth = function (b, c) {
        var d, e = a.xtGet;
        return b = a.safeObject(b), c = e(c, !0), d = e(b.actualWidth, b.width), this.actualWidth = d.toFixed ? this.actualWidth + d : this.actualWidth, c && (this.setDimensions(b), a.ctx[this.context].getContextFromEngine(a.context[this.name]), this.setDirtyHandles()), this
    }, a.Cell.prototype.setDeltaPasteHeight = function (b, c) {
        var d, e = a.xtGet;
        return b = a.safeObject(b), c = e(c, !0), d = e(b.pasteHeight, b.height), this.pasteHeight = this.pasteHeight.toFixed ? this.pasteHeight + d : a.addPercentages(this.pasteHeight, d), c && this.setDirtyHandles(), this
    }, a.Cell.prototype.setDeltaCopyHeight = function (b) {
        return b = a.safeObject(b), this.copyHeight = this.copyHeight.toFixed ? this.copyHeight + b.copyHeight : a.addPercentages(this.copyHeight, b.copyHeight), this
    }, a.Cell.prototype.setDeltaPasteWidth = function (b, c) {
        var d, e = a.xtGet;
        return b = a.safeObject(b), c = e(c, !0), d = e(b.pasteWidth, b.width), this.pasteWidth = this.pasteWidth.toFixed ? this.pasteWidth + d : a.addPercentages(this.pasteWidth, d), c && this.setDirtyHandles(), this
    }, a.Cell.prototype.setDeltaCopyWidth = function (b) {
        return b = a.safeObject(b), this.copyWidth = this.copyWidth.toFixed ? this.copyWidth + b.copyWidth : a.addPercentages(this.copyWidth, b.copyWidth), this
    }, a.Cell.prototype.setDeltaPaste = function (b, c) {
        var d, e, f, g = a.safeObject,
            h = a.xtGet,
            i = a.addPercentages,
            j = this.start;
        return b = g(b), c = a.xtGet(c, !0), d = g(b.paste), e = h(b.pasteX, d.x, 0), f = h(b.pasteY, d.y, 0), j.x = this.start.x.toFixed ? j.x + e : i(j.x, e), j.y = this.start.y.toFixed ? j.y + f : i(j.y, f), c && this.setDirtyStarts(), this
    }, a.Cell.prototype.setDeltaCopy = function (b) {
        var c, d, e, f = a.safeObject,
            g = a.xtGet,
            h = a.addPercentages,
            i = this.copy;
        return b = f(b), c = f(b.copy), d = g(b.copyX, c.x, 0), e = g(b.copyY, c.y, 0), i.x = d.toFixed ? i.x + d : h(i.x, d), i.y = e.toFixed ? i.y + e : h(i.y, e), this
    }, a.Cell.prototype.setEngine = function (b) {
        var c, d, e, f, g, h, i = a.ctx,
            j = this.setEngineActions,
            k = ["Gradient", "RadialGradient", "Pattern"];
        if (!b.fastStamp && (c = i[this.context], d = i[b.context], f = d.getChanges(b, c), Object.keys(f).length > 0)) {
            e = a.context[this.name], h = b.name, g = this.name;
            for (var l in f) j[l](f[l], e, k, h, g), c[l] = f[l]
        }
        return b
    }, a.Cell.prototype.setEngineActions = {
        fillStyle: function (b, c, d, e, f) {
            var g, h;
            a.xt(a.design[b]) ? (g = a.design[b], a.contains(d, g.type) && g.update(e, f), h = g.getData()) : h = b, c.fillStyle = h
        },
        font: function (a, b) {
            b.font = a
        },
        globalAlpha: function (a, b) {
            b.globalAlpha = a
        },
        globalCompositeOperation: function (a, b) {
            b.globalCompositeOperation = a
        },
        lineCap: function (a, b) {
            b.lineCap = a
        },
        lineDash: function (a, b) {
            b.mozDash = a, b.lineDash = a, b.setLineDash && b.setLineDash(a)
        },
        lineDashOffset: function (a, b) {
            b.mozDashOffset = a, b.lineDashOffset = a
        },
        lineJoin: function (a, b) {
            b.lineJoin = a
        },
        lineWidth: function (a, b) {
            b.lineWidth = a
        },
        shadowBlur: function (a, b) {
            b.shadowBlur = a
        },
        shadowColor: function (a, b) {
            b.shadowColor = a
        },
        shadowOffsetX: function (a, b) {
            b.shadowOffsetX = a
        },
        shadowOffsetY: function (a, b) {
            b.shadowOffsetY = a
        },
        strokeStyle: function (b, c, d, e, f) {
            var g, h;
            a.xt(a.design[b]) ? (g = a.design[b], a.contains(d, g.type) && g.update(e, f), h = g.getData()) : h = b, c.strokeStyle = h
        },
        miterLimit: function (a, b) {
            b.miterLimit = a
        },
        textAlign: function (a, b) {
            b.textAlign = a
        },
        textBaseline: function (a, b) {
            b.textBaseline = a
        },
        winding: function (a, b) {
            b.mozFillRule = a, b.msFillRule = a
        }
    }, a.Cell.prototype.groupSort = function () {
        this.sortGroups && (this.sortGroups = !1, this.groups = a.bucketSort("group", "order", this.groups))
    }, a.Cell.prototype.clear = function () {
        var b, c, d = this.actualWidth,
            e = this.actualHeight,
            f = this.backgroundColor;
        return c = a.context[this.name], b = a.ctx[this.context], c.setTransform(1, 0, 0, 1, 0, 0), c.clearRect(0, 0, d, e), "rgba(0,0,0,0)" !== f && (c.fillStyle = f, c.fillRect(0, 0, d, e), b.fillStyle = f), this
    }, a.Cell.prototype.compile = function (b) {
        var c, d, e;
        for (this.groupSort(), d = 0, e = this.groups.length; e > d; d++) c = a.group[this.groups[d]], c.visibility && c.stamp(!1, this.name, this, b);
        return this
    }, a.Cell.prototype.rotateDestination = function (a) {
        var b, c, d = this.flipReverse ? -1 : 1,
            e = this.flipUpend ? -1 : 1,
            f = this.addPathRoll ? this.roll + this.pathRoll : this.roll,
            g = this.pasteData;
        return f ? (f *= .01745329251, b = Math.cos(f), c = Math.sin(f), a.setTransform(b * d, c * d, -c * e, b * e, g.x, g.y), this) : (a.setTransform(d, 0, 0, e, g.x, g.y), this)
    }, a.Cell.prototype.prepareToCopyCell = function (b) {
        this.pasteData;
        return this.pivot ? this.setStampUsingPivot(a.pad[this.pad].base) : this.pathPrepareToCopyCell(), this.setCopy(), this.setPaste(), this.rotateDestination(b), this
    }, a.Cell.prototype.pathPrepareToCopyCell = function () {}, a.Cell.prototype.setCopy = function () {
        var b = a.isBetween,
            c = this.copyData,
            d = this.copy,
            e = this.numberConvert,
            f = Math.floor,
            g = this.copyWidth,
            h = this.copyHeight,
            i = this.actualWidth,
            j = this.actualHeight;
        return c.x = d.x.substring ? e(d.x, i) : d.x, c.y = d.y.substring ? e(d.y, j) : d.y, b(c.x, 0, i - 1, !0) || (c.x = c.x < 0 ? 0 : i - 1), b(c.y, 0, j - 1, !0) || (c.y = c.y < 0 ? 0 : j - 1), c.w = g.substring ? e(g, i) : g, c.h = h.substring ? e(h, j) : h, b(c.w, 1, i, !0) || (c.w = c.w < 1 ? 1 : i), b(c.h, 1, j, !0) || (c.h = c.h < 1 ? 1 : j), c.x + c.w > i && (c.x = i - c.w), c.y + c.h > j && (c.y = j - c.h), c.x = f(c.x), c.y = f(c.y), c.w = f(c.w), c.h = f(c.h), this
    }, a.Cell.prototype.setReference = function () {
        var b = a.safeObject,
            c = a.cell,
            d = b(a.pad[this.pad]),
            e = b(c[d.display]),
            f = b(c[d.base]),
            g = d.base ? !1 : !0,
            h = this.name === d.base ? !0 : !1,
            i = this.name === d.display ? !0 : !1,
            j = d.display ? !1 : !0;
        this.reference = j ? d : g ? !1 : h ? e : i ? d : f
    }, a.Cell.prototype.setPaste = function () {
        var b, c, d = a.safeObject,
            e = a.cell,
            f = d(a.pad[this.pad]),
            g = d(e[f.display]),
            h = d(e[f.base]),
            i = a.xt(f.group) ? !0 : !1,
            j = this.name === f.base ? !0 : !1,
            k = Math.floor,
            l = this.numberConvert,
            m = this.scale,
            n = this.pasteData,
            o = this.currentStart,
            p = a.xtGet;
        return a.xta(g, h) && (b = this.name === f.base ? g.actualWidth : p(h.actualWidth, this.actualWidth, 300), c = this.name === f.base ? g.actualHeight : p(h.actualHeight, this.actualHeight, 150), o.flag || (this.reference || this.setReference(), this.updateCurrentStart(this.reference)), n.x = o.x, n.y = o.y, n.w = this.pasteWidth, n.w.substring && (n.w = l(n.w, b)), j && i || (n.w *= m), n.h = this.pasteHeight, n.h.substring && (n.h = l(n.h, c)), j && i || (n.h *= m), n.w < 1 && (n.w = 1), n.h < 1 && (n.h = 1), n.x = k(n.x), n.y = k(n.y), n.w = k(n.w), n.h = k(n.h)), this
    }, a.Cell.prototype.copyCellToSelf = function (b) {
        var c, d, e, f, g, h, i;
        return b = b.substring ? a.cell[b] : b, a.xt(b) && (d = a.context[this.name], c = a.ctx[this.name], e = a.context[b.name], f = a.canvas[b.name], b.globalAlpha !== c.globalAlpha && (d.globalAlpha = b.globalAlpha, c.globalAlpha = b.globalAlpha), b.globalCompositeOperation !== c.globalCompositeOperation && (d.globalCompositeOperation = b.globalCompositeOperation, c.globalCompositeOperation = b.globalCompositeOperation), e.setTransform(1, 0, 0, 1, 0, 0), i = b.currentHandle, i.flag || b.updateCurrentHandle(), b.prepareToCopyCell(d), g = b.copyData, h = b.pasteData, d.drawImage(f, g.x, g.y, g.w, g.h, i.x, i.y, h.w, h.h)), this
    }, a.Cell.prototype.clearShadow = function (b) {
        var c = a.ctx[this.context];
        return b.shadowOffsetX = 0, b.shadowOffsetY = 0, b.shadowBlur = 0, c.shadowOffsetX = 0, c.shadowOffsetY = 0, c.shadowBlur = 0, this
    }, a.Cell.prototype.restoreShadow = function (b, c) {
        var d = a.ctx,
            e = d[this.context],
            f = d[c];
        return b.shadowOffsetX = f.shadowOffsetX, b.shadowOffsetY = f.shadowOffsetY, b.shadowBlur = f.shadowBlur, e.shadowOffsetX = f.shadowOffsetX, e.shadowOffsetY = f.shadowOffsetY, e.shadowBlur = f.shadowBlur, this
    }, a.Cell.prototype.setToClearShape = function () {
        var b, c;
        return c = a.context[this.name], b = a.ctx[this.context], c.fillStyle = "rgba(0, 0, 0, 0)", c.strokeStyle = "rgba(0, 0, 0, 0)", c.shadowColor = "rgba(0, 0, 0, 0)", b.fillStyle = "rgba(0, 0, 0, 0)", b.strokeStyle = "rgba(0, 0, 0, 0)", b.shadowColor = "rgba(0, 0, 0, 0)", this
    }, a.Cell.prototype.setDimensions = function (b) {
        var c = a.pad[this.pad],
            d = a.canvas[this.name],
            e = a.xtGet(b.width, b.actualWidth, this.actualWidth),
            f = a.xtGet(b.height, b.actualHeight, this.actualHeight);
        return c && (e.substring && (e = parseFloat(e) / 100 * (c.localWidth / c.scale)), f.substring && (f = parseFloat(f) / 100 * (c.localHeight / c.scale))), d.width = e, d.height = f, this.actualWidth = e, this.actualHeight = f, this
    }, a.Cell.prototype.saveContext = function () {
        return a.context[this.name].save(), this
    }, a.Cell.prototype.restoreContext = function () {
        return a.context[this.name].restore(), this
    }, a.Cell.prototype.getImageData = function (b) {
        var c, d, e, f, g, h = a.xtGet;
        return b = a.safeObject(b), g = b.name && b.name.substring ? this.name + "_" + b.name : this.name + "_imageData", c = h(b.x, 0), d = h(b.y, 0), e = h(b.width, this.actualWidth), f = h(b.height, this.actualHeight), a.imageData[g] = a.context[this.name].getImageData(c, d, e, f), g
    }, a.Context = function (b) {
        return b = a.safeObject(b), a.Base.call(this, b), b.cell ? this.getContextFromEngine(b.cell) : this.set(b), a.ctx[this.name] = this, a.pushUnique(a.ctxnames, this.name), this
    }, a.Context.prototype = Object.create(a.Base.prototype), a.Context.prototype.type = "Context", a.Context.prototype.classname = "ctxnames", a.work.d.Context = {
        fillStyle: "#000000",
        winding: "nonzero",
        strokeStyle: "#000000",
        globalAlpha: 1,
        globalCompositeOperation: "source-over",
        lineWidth: 1,
        lineCap: "butt",
        lineJoin: "miter",
        lineDash: [],
        lineDashOffset: 0,
        miterLimit: 10,
        shadowOffsetX: 0,
        shadowOffsetY: 0,
        shadowBlur: 0,
        shadowColor: "rgba(0,0,0,0)",
        font: "10pt sans-serif",
        textAlign: "start",
        textBaseline: "alphabetic"
    }, a.work.contextKeys = Object.keys(a.work.d.Context), a.mergeInto(a.work.d.Context, a.work.d.Base), a.Context.prototype.setDelta = function (b) {
        var c = a.xt,
            d = a.work.d.Context;
        return b = a.safeObject(b), c(b.lineDashOffset) && (c(this.lineDashOffset) || (this.lineDashOffset = d.lineDashOffset + b.lineDashOffset), this.lineDashOffset += b.lineDashOffset), c(b.lineWidth) && (c(this.lineWidth) || (this.lineWidth = d.lineWidth + b.lineWidth), this.lineWidth += b.lineWidth, this.lineWidth < 0 && (this.lineWidth = 0)), c(b.globalAlpha) && (c(this.globalAlpha) || (this.globalAlpha = d.globalAlpha + b.globalAlpha), this.globalAlpha += b.globalAlpha, a.isBetween(this.globalAlpha, 0, 1, !0) || (this.globalAlpha = this.globalAlpha > .5 ? 1 : 0)), this
    }, a.Context.prototype.getContextFromEngine = function (b) {
        for (var c = a.work.contextKeys, d = a.xtGet, e = 0, f = c.length; f > e; e++) this[c[e]] = b[c[e]];
        return this.winding = d(b.mozFillRule, b.msFillRule, "nonzero"), this.lineDash = a.xt(b.lineDash) ? b.lineDash : [], this.lineDashOffset = d(b.mozDashOffset, b.lineDashOffset, 0), this
    }, a.Context.prototype.getNonDefaultAttributes = function () {
        var b, c, d = a.work.d.Context,
            e = a.xt,
            f = a.work.contextKeys,
            g = {};
        for (b = 0, c = f.length; c > b; b++) "lineDash" === f[b] && this.lineDash && this.lineDash.length > 0 ? g.lineDash = this.lineDash : e(this[f[b]]) && this[f[b]] != d[f[b]] && (g[f[b]] = this[f[b]]);
        return g
    }, a.Context.prototype.getChanges = function (b, c) {
        var d, e, f, g, h = c.getNonDefaultAttributes(),
            i = Object.keys(h),
            j = this.getNonDefaultAttributes(),
            k = Object.keys(j),
            l = a.work.d.Context,
            m = {},
            n = a.contains;
        for (f = 0, g = i.length; g > f; f++) n(k, i[f]) || (m[i[f]] = l[i[f]]);
        for (f = 0, g = k.length; g > f; f++) "lineWidth" === k[f] && b.scaleOutline ? j.lineWidth * b.scale !== h.lineWidth && (m.lineWidth = j.lineWidth * b.scale) : j[k[f]] != h[k[f]] ? m[k[f]] = j[k[f]] : n(["fillStyle", "strokeStyle", "shadowColor"], k[f]) && (d = a.design[j[k[f]]], d && "Color" === d.type ? (e = d.getData(), e !== h[k[f]] && (m[k[f]] = e)) : "shadowColor" != k[f] && d && d.autoUpdate && (m[k[f]] = j[k[f]]));
        return m
    }, a.Group = function (b) {
        var c = a.xtGet,
            d = a.pushUnique;
        return b = a.safeObject(b), a.Base.call(this, b), this.entitys = a.xt(b.entitys) ? [].concat(b.entitys) : [], this.cell = b.cell || a.pad[a.work.currentPad].current, this.order = c(b.order, 0), this.resort = !0, this.visibility = c(b.visibility, !0), this.entitySort = c(b.entitySort, !0), this.regionRadius = c(b.regionRadius, 0), a.group[this.name] = this, d(a.groupnames, this.name), d(a.cell[this.cell].groups, this.name), this
    }, a.Group.prototype = Object.create(a.Base.prototype), a.Group.prototype.type = "Group", a.Group.prototype.classname = "groupnames", a.work.d.Group = {
        entitys: [],
        cell: "",
        order: 0,
        visibility: !0,
        entitySort: !0,
        resort: !1,
        regionRadius: 0
    }, a.mergeInto(a.work.d.Group, a.work.d.Base), a.Group.prototype.set = function (b) {
        return a.Base.prototype.set.call(this, b), a.xt(b.order) && (a.cell[this.cell].sortGroups = !0), this
    }, a.Group.prototype.sortEntitys = function (b) {
        (b || this.entitySort && this.resort) && (this.resort = !1, this.entitys = a.bucketSort("entity", "order", this.entitys))
    }, a.Group.prototype.forceStamp = function (a, b, c, d) {
        var e = this.visibility;
        return this.visibility = !0, this.stamp(a, b, c, d), this.visibility = e, this
    }, a.Group.prototype.stamp = function (b, c, d, e) {
        var f, g, h, i, j = a.entity;
        if (this.visibility)
            for (this.sortEntitys(), g = this.entitys, d = a.xt(d) ? d : a.cell[c], h = 0, i = g.length; i > h; h++) f = j[g[h]], f && (f.group = this.name, f.stamp(b, c, d, e));
        return this
    }, a.Group.prototype.addEntitysToGroup = function () {
        var b, c, d, e = [],
            f = a.pushUnique,
            g = this.entitys,
            h = a.xt;
        for (b = 0, c = arguments.length; c > b; b++) h(arguments[b]) && (Array.isArray(arguments[b]) ? e = e.concat(arguments[b]) : Array.isArray(arguments[b][0]) ? e = e.concat(arguments[b][0]) : e.push(arguments[b]));
        for (b = 0, c = e.length; c > b; b++) d = e[b], a.xt(d) && (d.substring ? f(g, d) : a.xt(d.name) && f(g, d.name));
        return this.resort = !0, this
    }, a.Group.prototype.removeEntitysFromGroup = function () {
        var b, c, d, e = [],
            f = a.removeItem,
            g = this.entitys,
            h = a.xt;
        for (b = 0, c = arguments.length; c > b; b++) h(arguments[b]) && (Array.isArray(arguments[b]) ? e = e.concat(arguments[b]) : Array.isArray(arguments[b][0]) ? e = e.concat(arguments[b][0]) : e.push(arguments[b]));
        for (b = 0, c = e.length; c > b; b++) d = e[b], a.xt(d) && (d.substring ? f(g, d) : a.xt(d.name) && f(g, d.name));
        return this.resort = !0, this
    }, a.Group.prototype.updateEntitysBy = function (b) {
        var c, d, e = this.entitys,
            f = a.entity,
            g = a.xt;
        for (b = a.safeObject(b), g(b.x) && (b.startX = b.x), g(b.y) && (b.startY = b.y), c = 0, d = e.length; d > c; c++) f[e[c]].setDelta(b);
        return this
    }, a.Group.prototype.setEntitysTo = function (b) {
        var c, d, e = this.entitys;
        for (c = 0, d = e.length; d > c; c++) a.entity[e[c]].set(b);
        return this
    }, a.Group.prototype.pivotEntitysTo = function (b) {
        var c, d, e, f, g, h, i = this.entitys,
            j = a.entity,
            k = a.work.v,
            l = {
                pivot: 0,
                handleX: 0,
                handleY: 0
            };
        if (b = b.substring ? b : !1, b && (c = j[b] || a.point[b] || !1))
            for (d = "Point" === c.type ? c.local : c.start, g = 0, h = i.length; h > g; g++) e = j[i[g]], f = k.set(e.start), f.vectorSubtract(d), l.pivot = b, l.handleX = -f.x, l.handleY = -f.y, e.set(l);
        return this
    }, a.Group.prototype.getEntityAt = function (b) {
        var c, d, e, f = a.work.colv1,
            g = a.work.colv2,
            h = this.entitys,
            i = a.entity,
            j = this.regionRadius;
        for (b = a.safeObject(b), d = f.set(b), d = a.Position.prototype.correctCoordinates(d, this.cell), this.sortEntitys(), e = h.length - 1; e >= 0; e--)
            if (c = i[h[e]], !(j && (g.set(c.currentStart).vectorSubtract(d), g.getMagnitude() > j)) && c.checkHit(d)) return c;
        return !1
    }, a.Group.prototype.getEntitysByMouseIndex = function (b) {
        var c, d, e, f = [],
            g = this.entitys,
            h = a.entity;
        if (b.substring)
            for (c = 0, d = g.length; d > c; c++) e = h[g[c]], e.mouseIndex === b && f.push(e);
        return f
    }, a.Group.prototype.getAllEntitysAt = function (b) {
        var c, d, e, f, g = a.work.colv1,
            h = a.work.colv2,
            i = this.entitys,
            j = a.entity,
            k = this.regionRadius;
        for (b = a.safeObject(b), d = g.set(b), e = [], d = a.Position.prototype.correctCoordinates(d, this.cell), this.sortEntitys(), f = i.length - 1; f >= 0; f--) c = j[i[f]], k && (h.set(c.currentStart).vectorSubtract(d), h.getMagnitude() > k) || c.checkHit(d) && e.push(c);
        return e.length > 0 ? e : !1
    }, a.Group.prototype.setDirtyStarts = function () {
        var b, c, d, e = a.entity,
            f = this.entitys,
            g = a.xt;
        for (c = 0, d = f.length; d > c; c++) b = e[f[c]], g(b) && (b.currentStart.flag = !1);
        return this
    }, a.Group.prototype.setDirtyHandles = function () {
        var b, c, d, e = a.entity,
            f = this.entitys,
            g = a.xt;
        for (c = 0, d = f.length; d > c; c++) b = e[f[c]], g(b) && (b.currentHandle.flag = !1);
        return this
    }, a.Entity = function (b) {
        var c = a.xtGet;
        b = a.safeObject(b), a.Position.call(this, b), b.name = this.name;
        var d = a.makeContext(b);
        return this.context = d.name, this.group = this.getGroup(b), this.fastStamp = c(b.fastStamp, !1), this.scaleOutline = c(b.scaleOutline, !0), this.order = c(b.order, 0), this.visibility = c(b.visibility, !0), this.method = c(b.method, a.work.d[this.type].method), this.collisionsEntityConstructor(b), this.filtersEntityInit(b), this
    }, a.Entity.prototype = Object.create(a.Position.prototype), a.Entity.prototype.type = "Entity", a.Entity.prototype.classname = "entitynames", a.work.d.Entity = {
        order: 0,
        visibility: !0,
        method: "fill",
        data: "",
        radius: 0,
        scaleOutline: !0,
        fastStamp: !1,
        context: "",
        group: ""
    }, a.mergeInto(a.work.d.Entity, a.work.d.Position), a.Entity.prototype.filtersEntityInit = function () {}, a.Entity.prototype.collisionsEntityConstructor = function () {}, a.Entity.prototype.registerInLibrary = function (b) {
        return a.entity[this.name] = this, a.pushUnique(a.entitynames, this.name), a.group[this.group].addEntitysToGroup(this.name), this.collisionsEntityRegisterInLibrary(b), this
    }, a.Entity.prototype.collisionsEntityRegisterInLibrary = function () {}, a.Entity.prototype.get = function (b) {
        var c = a.xt,
            d = a.work.d;
        return c(d.Base[b]) ? a.Base.prototype.get.call(this, b) : c(d.Context[b]) ? a.ctx[this.context].get(b) : a.Position.prototype.get.call(this, b)
    }, a.Entity.prototype.set = function (b) {
        {
            var c = a.group,
                d = a.xt;
            a.xto
        }
        return a.Position.prototype.set.call(this, b), a.ctx[this.context].set(b), b = a.safeObject(b), d(b.group) && b.group !== this.group && (c[this.group].removeEntitysFromGroup(this.name), this.group = this.getGroup(b.group), c[this.group].addEntitysToGroup(this.name)), this.collisionsEntitySet(b), d(b.order) && (c[this.group].resort = !0), d(b.lineWidth) && (this.maxDimensions.flag = !0), this
    }, a.Entity.prototype.collisionsEntitySet = function () {}, a.Entity.prototype.setDelta = function (b) {
        return a.Position.prototype.setDelta.call(this, b), b = a.safeObject(b), a.xto(b.lineDashOffset, b.lineWidth, b.globalAlpha) && (a.ctx[this.context].setDelta(b), a.xt(b.lineWidth) && (this.maxDimensions.flag = !0)), this.collisionsEntitySetDelta(b), this
    }, a.Entity.prototype.collisionsEntitySetDelta = function () {}, a.Entity.prototype.clone = function (b) {
        var c, d, e;
        return b = a.safeObject(b), c = JSON.parse(JSON.stringify(a.ctx[this.context])), delete c.name, d = a.mergeInto(b, c), delete d.context, e = a.Position.prototype.clone.call(this, d), a.xt(b.createNewContext) && !b.createNewContext && (delete a.ctx[e.context], a.removeItem(a.ctxnames, e.context), e.context = this.context), e
    }, a.Entity.prototype.getGroup = function (b) {
        return b = a.safeObject(b), a.xt(b.group) && a.group[b.group] ? b.group : a.pad[a.work.currentPad].current
    }, a.Entity.prototype.getEntityCell = function (b) {
        return a.cell[a.group[this.getGroup(b)].cell]
    }, a.Entity.prototype.forceStamp = function (a, b, c, d) {
        var e = this.visibility;
        return this.visibility = !0, this.stamp(a, b, c, d), this.visibility = e, this
    }, a.Entity.prototype.stamp = function (b, c, d, e) {
        var f, g = !this.currentStart.flag,
            h = !this.currentHandle.flag;
        return this.visibility && (d || (d = a.cell[c] || a.cell[a.group[this.group].cell], c = d.name), f = a.context[c], b = b || this.method, (g || h) && (g && this.updateCurrentStart(d), h && this.updateCurrentHandle(), this.resetCollisionPoints()), this.pivot ? (this.setStampUsingPivot(c, e), this.maxDimensions.flag = !0) : this.pathStamp(), this[b](f, c, d), this.stampFilter(f, c, d)), this
    }, a.Entity.prototype.resetCollisionPoints = function () {}, a.Entity.prototype.pathStamp = function () {}, a.Entity.prototype.stampFilter = function () {}, a.Entity.prototype.stampFilterDimensionsActions = {}, a.Entity.prototype.rotateCell = function (a) {
        var b, c, d = this.flipReverse ? -1 : 1,
            e = this.flipUpend ? -1 : 1,
            f = this.addPathRoll ? this.roll + this.pathRoll : this.roll,
            g = this.currentStart;
        return f ? (f *= .01745329251, b = Math.cos(f), c = Math.sin(f), a.setTransform(b * d, c * d, -c * e, b * e, g.x, g.y), this) : (a.setTransform(d, 0, 0, e, g.x, g.y), this)
    }, a.Entity.prototype.getStartValues = function () {
        var a = this.currentStart;
        return {
            x: a.x,
            y: a.y
        }
    }, a.Entity.prototype.getHandleValues = function () {
        var a = this.currentHandle;
        return {
            x: a.x,
            y: a.y
        }
    }, a.Entity.prototype.getStart = function () {
        var b = a.work.v.set(this.currentStart).vectorAdd(this.currentHandle);
        return {
            x: b.x,
            y: b.y
        }
    }, a.Entity.prototype.clear = function () {
        return this
    }, a.Entity.prototype.clearWithBackground = function () {
        return this
    }, a.Entity.prototype.draw = function () {
        return this
    }, a.Entity.prototype.fill = function () {
        return this
    }, a.Entity.prototype.drawFill = function () {
        return this
    }, a.Entity.prototype.fillDraw = function () {
        return this
    }, a.Entity.prototype.sinkInto = function () {
        return this
    }, a.Entity.prototype.floatOver = function () {
        return this
    }, a.Entity.prototype.clip = function () {
        return this
    }, a.Entity.prototype.none = function (a, b, c) {
        return c.setEngine(this), this
    }, a.Entity.prototype.clearShadow = function (b, c) {
        var d = a.ctx[this.context];
        return (d.shadowOffsetX || d.shadowOffsetY || d.shadowBlur) && c.clearShadow(b), this
    }, a.Entity.prototype.restoreShadow = function (b, c) {
        var d = a.ctx[this.context];
        return (d.shadowOffsetX || d.shadowOffsetY || d.shadowBlur) && c.restoreShadow(b, this.context), this
    }, a.Entity.prototype.pickupEntity = function (b) {
        var c, d;
        return b = a.safeObject(b), d = a.work.v.set(b), c = a.cell[a.group[this.group].cell], d = this.correctCoordinates(d, c), this.oldX = d.x || 0, this.oldY = d.y || 0, this.oldPivot = this.pivot, this.mouseIndex = a.xtGet(b.id || "mouse"), this.pivot = "mouse", this.currentPivotIndex = !1, this.order += 9999, a.group[this.group].resort = !0, this
    }, a.Entity.prototype.dropEntity = function (b) {
        return this.pivot = a.xtGet(b, this.oldPivot, null), this.currentPivotIndex = !1, this.order = this.order >= 9999 ? this.order - 9999 : 0, delete this.oldPivot, delete this.oldX, delete this.oldY, this.mouseIndex = "mouse", a.group[this.group].resort = !0, this.start.x = this.currentStart.x, this.start.y = this.currentStart.y, this.currentHandle.flag = !1, this.setPaste && this.setPaste(), this
    }, a.Entity.prototype.checkHit = function (b) {
        var c, d, e, f, g, h, i = [],
            j = this.currentHandle,
            k = this.localWidth,
            l = this.localHeight,
            m = this.scale,
            n = a.work.cvx;
        for (b = a.safeObject(b), a.xt(b.tests) ? i = b.tests : (i.length = 0, i.push(b.x || 0), i.push(b.y || 0)), this.rotateCell(n, this.getEntityCell().name), j.flag || this.updateCurrentHandle(), c = j, g = k ? k : this.width * m, h = l ? l : this.height * m, n.beginPath(), n.rect(c.x, c.y, g, h), e = 0, f = i.length; f > e && !(d = n.isPointInPath(i[e], i[e + 1])); e += 2);
        return d ? (b.x = i[e], b.y = i[e + 1], b) : !1
    }, a.Design = function (b) {
        return a.Base.call(this, b), this.lockTo = a.xtGet(b.lockTo, a.work.d[this.type].lockTo), this
    }, a.Design.prototype = Object.create(a.Base.prototype), a.Design.prototype.type = "Design", a.Design.prototype.classname = "designnames", a.work.d.Design = {
        color: [{
            color: "black",
            stop: 0
        }, {
            color: "white",
            stop: .999999
        }],
        lockTo: "cell",
        autoUpdate: !1,
        cell: "",
        startX: 0,
        startY: 0,
        endX: 0,
        endY: 0
    }, a.mergeInto(a.work.d.Design, a.work.d.Base), a.Design.prototype.set = function (b) {
        var c, d = a.xto,
            e = a.safeObject,
            f = a.xtGet;
        return b = a.safeObject(b), d(b.startX, b.startY, b.startRadius, b.start) && (c = e(b.start), this.startX = f(c.x, c.startX, b.startX, this.startX), this.startY = f(c.y, c.startY, b.startY, this.startY), this.startRadius = f(c.r, c.startRadius, b.startRadius, this.startRadius)), d(b.endX, b.endY, b.endRadius, b.end) && (c = e(b.end), this.endX = f(c.x, c.endX, b.endX, this.endX), this.endY = f(c.y, c.endY, b.endY, this.endY), this.endRadius = f(c.r, c.endRadius, b.endRadius, this.endRadius)), b.shift && a.xt(a.work.d.Design.shift) && (this.shift = b.shift), this
    }, a.Design.prototype.setDelta = function (b) {
        var c, d = a.addPercentages;
        return b = a.safeObject(b), b.startX && (c = this.get("startX"), this.startX = b.startX.substring ? d(c, b.startX) : c + b.startX), b.startY && (c = this.get("startY"), this.startY = b.startY.substring ? d(c, b.startY) : c + b.startY), b.startRadius && (c = this.get("startRadius"), this.startRadius = c + b.startRadius), b.endX && (c = this.get("endX"), this.endX = b.endX.substring ? d(c, b.endX) : c + b.endX), b.endY && (c = this.get("endY"), this.endY = b.endY.substring ? d(c, b.endY) : c + b.endY), b.endRadius && (c = this.get("endRadius"), this.endRadius = c + b.endRadius), b.shift && a.xt(a.work.d.Design.shift) && (c = this.get("shift"), this.shift = c + b.shift), this
    }, a.Design.prototype.update = function (a, b) {
        return this.makeGradient(a, b), this.applyStops(), this
    }, a.Design.prototype.getData = function () {
        return a.xt(a.dsn[this.name]) ? a.dsn[this.name] : "rgba(0,0,0,0)"
    }, a.Design.prototype.makeGradient = function (b, c) {
        var d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, y = a.cell,
            z = a.xt,
            A = a.work.v;
        if (b = a.entity[b] || !1, c = z(c) ? y[c] ? y[c] : y[this.get("cell")] : b ? y[b.group] : y[this.get("cell")], d = a.context[c.name], this.lockTo && "cell" !== this.lockTo) {
            switch (u = b.currentHandle, b.type) {
                case "Wheel":
                    i = -u.x + b.radius * b.scale, j = -u.y + b.radius * b.scale;
                    break;
                case "Shape":
                case "Path":
                    b.isLine ? (i = -u.x, j = -u.y) : (i = -u.x + b.width / 2 * b.scale, j = -u.y + b.height / 2 * b.scale);
                    break;
                default:
                    i = -u.x, j = -u.y
            }
            v = z(b.localWidth) ? b.localWidth : b.width * b.scale, w = z(b.localHeight) ? b.localHeight : b.height * b.scale, k = z(this.startX) ? this.startX : 0, k.substring && (k = parseFloat(k) / 100 * v), l = z(this.startY) ? this.startY : 0, l.substring && (l = parseFloat(l) / 100 * w), n = z(this.endX) ? this.endX : v, n.substring && (n = parseFloat(n) / 100 * v), o = z(this.endY) ? this.endY : w, o.substring && (o = parseFloat(o) / 100 * w), "Gradient" === this.type ? h = d.createLinearGradient(k - i, l - j, n - i, o - j) : (m = z(this.startRadius) ? this.startRadius : 0, m.substring && (m = parseFloat(m) / 100 * v), p = z(this.endRadius) ? this.endRadius : v, p.substring && (p = parseFloat(p) / 100 * v), h = d.createRadialGradient(k - i, l - j, m, n - i, o - j, p))
        } else e = b.numberConvert, f = c.actualWidth, g = c.actualHeight, i = b.start.x, i.substring && (i = e(i, f)), j = b.start.y, j.substring && (j = e(j, g)), k = z(this.startX) ? this.startX : 0, k.substring && (k = e(k, f)), l = z(this.startY) ? this.startY : 0, l.substring && (l = e(l, g)), n = z(this.endX) ? this.endX : f, n.substring && (n = e(n, f)), o = z(this.endY) ? this.endY : g, o.substring && (o = e(o, g)), i = b.flipReverse ? f - i : i, j = b.flipUpend ? g - j : j, k = b.flipReverse ? f - k : k, l = b.flipUpend ? g - l : l, n = b.flipReverse ? f - n : n, o = b.flipUpend ? g - o : o, q = k - i, r = l - j, s = n - i, t = o - j, x = b.roll, (b.flipReverse && b.flipUpend || !b.flipReverse && !b.flipUpend) && (x = -b.roll), b.roll && (A.set({
            x: q,
            y: r,
            z: 0
        }).rotate(x), q = A.x, r = A.y, A.set({
            x: s,
            y: t,
            z: 0
        }).rotate(x), s = A.x, t = A.y), "Gradient" === this.type ? h = d.createLinearGradient(q, r, s, t) : (m = z(this.startRadius) ? this.startRadius : 0, m.substring && (m = parseFloat(m) / 100 * c.actualWidth), p = z(this.endRadius) ? this.endRadius : c.actualWidth, p.substring && (p = parseFloat(p) / 100 * c.actualWidth), h = d.createRadialGradient(q, r, m, s, t, p));
        return a.dsn[this.name] = h, this
    }, a.Design.prototype.applyStops = function () {
        var b, c, d = this.get("color"),
            e = a.dsn[this.name];
        if (e)
            for (b = 0, c = d.length; c > b; b++) e.addColorStop(d[b].stop, d[b].color);
        return this
    }, a.Design.prototype.remove = function () {
        return delete a.dsn[this.name], delete a.design[this.name], a.removeItem(a.designnames, this.name), !0
    }, a.Gradient = function (b) {
        return b = a.safeObject(b), a.Design.call(this, b), a.Base.prototype.set.call(this, b), a.design[this.name] = this, a.pushUnique(a.designnames, this.name), this
    }, a.Gradient.prototype = Object.create(a.Design.prototype), a.Gradient.prototype.type = "Gradient", a.Gradient.prototype.classname = "designnames", a.work.d.Gradient = {}, a.mergeInto(a.work.d.Gradient, a.work.d.Design), a.RadialGradient = function (b) {
        return b = a.safeObject(b), a.Design.call(this, b), a.Base.prototype.set.call(this, b), a.design[this.name] = this, a.pushUnique(a.designnames, this.name), this
    }, a.RadialGradient.prototype = Object.create(a.Design.prototype), a.RadialGradient.prototype.type = "RadialGradient", a.RadialGradient.prototype.classname = "designnames", a.work.d.RadialGradient = {
        startRadius: 0,
        endRadius: 0
    }, a.mergeInto(a.work.d.RadialGradient, a.work.d.Design), a.work.v = a.makeVector({
        name: "scrawl.v"
    }), a.work.colv1 = a.makeVector({
        name: "scrawl.colv"
    }), a.work.colv2 = a.makeVector({
        name: "scrawl.colv"
    }), a.makeAnimation = function (b) {
        return new a.Animation(b)
    }, a.newAnimation = function (b) {
        return a.makeAnimation(b)
    }, a.work.animate = [], a.work.doAnimation = !1, a.work.orderAnimations = !0, a.work.resortAnimations = !0, a.animationLoop = function () {
        var b, c, d = a.work.animate,
            e = a.animation;
        for (a.work.orderAnimations && a.sortAnimations(), b = 0, c = d.length; c > b; b++) d[b] && e[d[b]].fn();
        a.work.doAnimation && window.requestAnimFrame(function () {
            a.animationLoop()
        })
    }, a.sortAnimations = function () {
        a.work.resortAnimations && (a.work.resortAnimations = !1, a.work.animate = a.bucketSort("animation", "order", a.work.animate))
    }, a.animationInit = function () {
        a.makeAnimation({
            fn: function () {
                var b, c, d = a.device;
                b = d.getViewportDimensions(), c = d.getViewportPosition(), b && a.setPerspectives(), (b || c) && a.setDisplayOffsets("all")
            }
        }), a.work.doAnimation = !0, a.animationLoop()
    }, a.Animation = function (b) {
        var c;
        return a.Base.call(this, b), b = a.safeObject(b), c = a.isa_bool(b.delay) ? b.delay : !1, this.fn = b.fn || function () {}, this.order = b.order || 0, a.animation[this.name] = this, a.pushUnique(a.animationnames, this.name), a.work.resortAnimations = !0, c || this.run(), this
    }, a.Animation.prototype = Object.create(a.Base.prototype), a.Animation.prototype.type = "Animation", a.Animation.prototype.classname = "animationnames", a.work.d.Animation = {
        fn: function () {},
        order: 0
    }, a.mergeInto(a.work.d.Animation, a.work.d.Base), a.Animation.prototype.run = function () {
        return a.pushUnique(a.work.animate, this.name), !0
    }, a.Animation.prototype.isRunning = function () {
        return a.contains(a.work.animate, this.name)
    }, a.Animation.prototype.halt = function () {
        return a.removeItem(a.work.animate, this.name), !0
    }, a.Animation.prototype.kill = function () {
        return delete a.animation[this.name], a.removeItem(a.animationnames, this.name), a.removeItem(a.work.animate, this.name), a.work.resortAnimations = !0, !0
    };
    return a
}();
